'/* BCRE.BAS  Create a Btrieve file using a data table (filename.CRE) */
'/*           By: Dale Thorn                                          */
'/*           Rev. 21.06.1999                                         */

'$include: 'basdef.h'
'$include: 'btrieve.h'
'$include: 'btrvfcre.h'
'$include: 'filekill.h'
'$include: 'fileopen.h'
'$include: 'longname.h'
'$include: 'messages.h'
'$include: 'midchar.h'
'$include: 'parmstr1.h'
'$include: 'string.h'
'$include: 'basdef.bas'
'$include: 'btrieve.bas'
'$include: 'btrvfcre.bas'
'$include: 'filekill.bas'
'$include: 'fileopen.bas'
'$include: 'longname.bas'
'$include: 'messages.bas'
'$include: 'midchar.bas'
'$include: 'parmstr1.bas'
'$include: 'string.bas'
'$include: 'scrnparm.bas'

ccmd = ucase$(rtrim$(command$))            'get the DOS command-line parameters

if ccmd = "" then                              'a command line was not supplied
   i = ifn.msgs("Usage:  BCRE  filename", iofs, irow, icol, 0, 1)
end if                              'display the usage message [above] and exit

iprm = parmstr1(ccmd, cfil, cnam, cext, cprm())  'parse command-line parameters

if len(cnam) = 0 or len(cnam) > 8 or len(cext) > 3 or instr(cext, ".") _
or iprm >= 0 then        'user gave an invalid filename or supplied a parameter
   i = ifn.msgs("Invalid filename", iofs, irow, icol, 1, 1)
end if                       'display invalid-filename message [above] and exit

csrc = cnam + ".cre"                               'set the data table filename
i = ifn.open(1, csrc, "b", llof)           'open the source file in binary mode
if llof < 0 then                                'user input a wildcard filespec
   i = ifn.msgs("Invalid filename", iofs, irow, icol, 1, 1)      'beep and exit
elseif llof = 0 then                          'source file nonexistent or empty
   i = ifn.kill(1, csrc)                             'kill the zero-length file
   i = ifn.msgs(csrc + " not found", iofs, irow, icol, 1, 1)     'beep and exit
end if
close 1                                   'close the binary-access file channel

i = ifn.msgs("Please standby", iofs, irow, icol, 0, 0) 'hide cursor and proceed
if io.btrvfcre(csrc, cfil) then        'non-OK status creating the Btrieve file
   i = ifn.msgs("An error occurred creating " + cfil, iofs, irow, icol, 1, 1)
else                                         'Btrieve file created successfully
   i = ifn.msgs(cfil + " created successfully", iofs, irow, icol, 0, 1)
end if

close                                 'close all files in case not closed above
system                                   'exit program in case not exited above
