'/*  BROWSER.BAS  Multi-file Btrieve/ISAM/etc. command-line browser */
'/*               By: Dale Thorn                                    */
'/*               Rev. 10.05.2002                                   */

'$include: 'basdef.h'
'$include: 'basio.h'
'$include: 'browse.h'
'$include: 'btrieve.h'
'$include: 'filekill.h'
'$include: 'fileopen.h'
'$include: 'longname.h'
'$include: 'messages.h'
'$include: 'midchar.h'
'$include: 'parmstr1.h'
'$include: 'string.h'

type bpas                                 'pass structure for ibr.load function
   begfld as integer                      'offset to the beginning field number
   fldsav as integer                     'bc.fldmax value from last BROWSE call
   matpos as integer                      'if g.t. 0, match all file extensions
   pginit as integer                        'initialization flag for file-opens
   cexten as string * 3                        'command-line filename extension
   cvfile as string * 40                       'filename + .cf? for *.cf* files
end type

declare function ibr.load(bc as bcnf, bp as bpas, _
cdir, cdat(), ckey(), crcd(), iptr())

'$include: 'basdef.bas'
'$include: 'basiob1.bas'
'$include: 'btrieve.bas'
'$include: 'filekill.bas'
'$include: 'fileopen.bas'
'$include: 'longname.bas'
'$include: 'messages.bas'
'$include: 'midchar.bas'
'$include: 'parmstr1.bas'
'$include: 'string.bas'
'$include: 'scrnparm.bas'
'$include: 'clrparm.bas'

dim cdat(7, -22 to 22), ckey(28), ckvl(22), cpos(27), _
    crcd(1, 9), cvdb(27), iptr(17, -22 to 22)
dim bc as bcnf                                   'Browse options pass-structure
dim bp as bpas                       'struct values passed to IBR.LOAD function

ccmd = ucase$(rtrim$(command$))                'get DOS command-line parameters
if ccmd = "" then                                 'a filename was not specified
   i = ifn.msgs("Usage:  BROWSER  filename  [/M /Rn /0 [1, 2...]]", _
                iofs, irow, icol, 0, 1)     'display the usage message and exit
end if

bp.matpos = instr(ccmd, "/M")      'force file extension matching for files 0-9
if bp.matpos then                        'file extension matching was specified
   ccmd = left$(ccmd, bp.matpos - 1) + mid$(ccmd, bp.matpos + 2)   'remove '/M'
end if

idecpos = instr(ccmd, "/R")                      'float decimal places override
if idecpos then                                   'user specified d.p. override
   bc.declen = pdqvali(mid$(ccmd, idecpos + 2, 1))    'get user's d.p. override
   ccmd = left$(ccmd, idecpos - 1) + mid$(ccmd, idecpos + 3) 'remove '/R' param.
end if
if bc.declen = 0 then                        'invalid d.p. override was entered
   bc.declen = 4                                'default the d.p. override to 4
end if

iprm = parmstr1(ccmd, cfil, cnam, cext, cprm())  'parse command-line parameters
if cnam = "" or len(cnam) > 8 or len(cext) > 3 or instr(cext, ".") _
or iprm > 0 then                 'invalid filename or no. of parameters was > 1
   i = ifn.msgs("Invalid filename", iofs, irow, icol, 1, 1)
end if                       'display invalid-filename message [above] and exit
if iprm = -1 then                     '.cf? script file extension not specified
   cprm(0) = "0"                       'default to '.cf0' script file extension
end if

bp.cexten = cext                               'command-line filename extension
bp.cvfile = "cf0\" + cnam + ".cf" + cprm(0)   '.cf? script (configuration) file
cdir = left$(cfil, istr.rcfn(len(cfil), cfil, "\"))  'full path for target file
bp.begfld = 0                                'beginning field no. initial value
bp.pginit = not 0                    'set initialization flag for file opens ON

if iclr < 16 then                                           'LCD/b&w color spec
   bc.clrbar = iclr * 16                                      'scroll-bar color
else                                                         'normal color spec
   bc.clrbar = iclr \ 16                                      'scroll-bar color
end if
bc.clrdat = iclr                                               'data area color
bc.clredt = iclr                                               'edit-cell color
bc.clrerr = iclr                                           'error message color
bc.clrftr = iclr                                       'footer message(s) color
bc.clrhdr = iclr                                       'main header title color
bc.clrmsg = iclr                                        'standard message color
bc.clrttl = iclr                                           'column titles color
bc.clrwin = iclr                                           'window border color

bc.auxkey = KEY.CTLLT                        'initial value; set to browse mode
bc.csep   = "/"                      'date separator ('/', '.', etc.) character
bc.keyout = 5                            'buffered-key timeout (0 = no timeout)
bc.linext = 1                             'window-border line width (0, 1 or 2)
bc.linint = 0                                     'internal-line width (0 or 1)
bc.padext = not 0                              'TRUE if OK to pad l&r of screen
bc.xkey01 = KEY.ESC                                         'browse exit-key #1

do                                            'loop until user presses exit key
   i = ibr.load(bc, bp, cdir, cdat(), ckey(), crcd(), iptr())'read script&setup
   bp.pginit = 0                      'clear initialization flag for file-opens
   color 0, 7                               'set the standard DOS display color
   cls                                            'pre-clear the display screen
   i = browse(bc, cdat(), ckey(), ckvl(), cpos(), crcd(), cvdb(), iptr())
   if bc.auxkey = KEY.CTEND then          'Ctrl-End; move to last browse fields
      bp.begfld = bp.fldsav - abs(bp.fldsav > 0)    'last or next-to-last field
   elseif bc.auxkey = KEY.CTHOM then    'Ctrl-Home; move to first browse fields
      bp.begfld = 0                              'begin browse with first field
   elseif bc.auxkey = KEY.CTLLT then   'Ctrl-Left; shift left by 1 browse field
      if bp.begfld > 0 then            'current screen begins with >first field
         bp.begfld = bp.begfld - 1              'shift left by one browse field
      end if
   elseif bc.auxkey = KEY.CTLRT then 'Ctrl-Right; shift right by 1 browse field
      if bc.fldmax + bp.begfld < bp.fldsav then   'screen ends with <last field
         bp.begfld = bp.begfld + 1             'shift right by one browse field
      end if
   else                             'user pressed exit key - exit and shut down
      exit do
   end if
loop

for ifil = 0 to bc.filmax             'loop thru files specified in this browse
   i = BTRV(BTRV.CLOSE, crcd(1, ifil), "", 0, "", 0)   'close each Btrieve file
next
color 0, 7                                  'set the standard DOS display color
i = ifn.msgs("", iofs, irow, icol, 0, 1)     'clear the display screen and exit

close                                 'close all files in case not closed above
system                                   'exit program in case not exited above

function ibr.load(bc as bcnf, bp as bpas, cdir, cdat(), ckey(), crcd(), iptr())
'$include: 'scrnparm.bas'
   dim cnam(9), csec(9)              'Btrieve filenames and security specifiers
   i = ifn.open(iunit, bp.cvfile, "s", llof)'open scriptfile in sequential mode
   if llof < 0 then                             'user input a wildcard filespec
      i = ifn.msgs("Invalid filename", iofs, irow, icol, 1, 1)   'beep and exit
   elseif llof = 0 then                       'script file nonexistent or empty
      i = ifn.kill(iunit, bp.cvfile)          'kill the zero-length script file
      i = ifn.msgs(rtrim$(bp.cvfile) + " not found", iofs, irow, icol, 1, 1)
   end if                      'display file-not-found message [above] and exit
   line input #iunit, ca                       'header for no. of Btrieve files
   line input #iunit, ca                    'no. of Btrieve files (string form)
   bc.filmax = pdqvali(ca) - 1                  'no. of Btrieve files (numeric)
   for ifil = 0 to bc.filmax          'loop thru files specified in this browse
      line input #iunit, ca           'header for name/len/key#/length/pad/mask
      input #iunit, ca                          'filename or security specifier
      if ucase$(ca) = "SECURE" then               'security specifier was found
         csec(ifil) = ucase$(ca)          'set security specifier for this file
         input #iunit, ca        'reload filename when security specifier found
      else                                        'security specifier not found
         csec(ifil) = ""                'clear security specifier for this file
      end if
      input #iunit, cb, _                                    'get record length
                    cc, _                                       'get key number
                    cd, _                                       'get key length
                    cdat(7, ifil + 10), _                      'get key padding
                    ckey(ifil + 10)                               'get key mask
      if csec(ifil) <> "" then                    'security specifier was found
         input #iunit, csec(ifil)              'load security passphrase string
      end if
      if bp.pginit then              'initialization flag is ON (first time in)
         if (ifil = 0 or bp.matpos > 0) and asc(bp.cexten) <> 32 then
            ichrpos = instr(ca, ".")       'extension position from script file
            if ichrpos = 0 then         'extension not specified in script file
               ichrpos = len(ca) + 1 'set extension position to end of filename
            end if
            ca = left$(ca, ichrpos - 1) + "." + bp.cexten'sub.command-line ext.
         end if
         cnam(ifil) = ca                                  'get Btrieve filename
         iptr(4, ifil) = pdqvali(cb)                  'get record buffer length
         crcd(0, ifil) = string$(iptr(4, ifil), 0)      'allocate record buffer
         crcd(1, ifil) = string$(128, 0)           'allocate file control block
         iptr(7, ifil) = pdqvali(cc)                    'get Btrieve key number
         ckey(ifil) = string$(pdqvali(cd), 0)  'allocate key buffer from keylen
         itagfld = -1                 'initialize to NO tag (updateable) fields
      end if
   next
   line input #iunit, ca                          'key segments info message #1
   line input #iunit, ca                          'key segments info message #2
   line input #iunit, ca                          'key segments info message #3
   for ifil = 0 to bc.filmax          'loop thru files specified in this browse
      line input #iunit, ca             'header for key segments, begin, length
      input #iunit, ca                       'no. of key segments (string form)
      iptr(7, ifil + 10) = pdqvali(ca) - 1       'no. of key segments (numeric)
      for iseg = 0 to iptr(7, ifil + 10)            'loop thru the key segments
         input #iunit, ca                      'key segment begin (string form)
         iptr(ifil + 8, iseg) = pdqvali(ca)        'key segment begin (numeric)
         input #iunit, ca                     'key segment length (string form)
         iptr(ifil + 8, iseg + 10) = pdqvali(ca)  'key segment length (numeric)
      next
   next
   line input #iunit, ca                      'header for display field padding
   line input #iunit, ca                   'display field padding (string form)
   bc.padint = pdqvali(ca)                     'display field padding (numeric)
   line input #iunit, ca                        'header for hold line on paging
   line input #iunit, ca                     'hold line on paging (string form)
   bc.holdln = pdqvali(ca)                       'hold line on paging (numeric)
   line input #iunit, ca                       'header for no. of search fields
   line input #iunit, ca                    'no. of search fields (string form)
   bc.edtmax = pdqvali(ca) - 1                  'no. of search fields (numeric)
   for iedit = 0 to bc.edtmax               'loop thru the no. of search fields
      line input #iunit, ca             'header for search field#, begin, width
      input #iunit, ca                       'search field field# (string form)
      iptr(5, iedit) = pdqvali(ca) - 1           'search field field# (numeric)
      input #iunit, ca                   'search field begin col. (string form)
      iptr(5, iedit + 10) = pdqvali(ca) - 1          'search field begin column
      input #iunit, ca                        'search field width (string form)
      iptr(6, iedit) = pdqvali(ca)                'search field width (numeric)
   next
   line input #iunit, ca                          'header for minimum key value
   line input #iunit, ca                       'minimum key value (string form)
   ckeylow = ""                                  'initialize minimum key buffer
   ichrpos = 0                           'key-value string begin-parse position
   do                                        'loop to extract minimum key bytes
      ckeylow = ckeylow + char(pdqvali(mid$(ca, ichrpos + 1)))'add the key byte
      ichrpos = instr(ichrpos + 1, ca, ",")        'move to next parse position
   loop while ichrpos                 'loop while next parse position available
   line input #iunit, ca                          'header for maximum key value
   line input #iunit, ca                       'maximum key value (string form)
   ckeyhgh = ""                                  'initialize maximum key buffer
   ichrpos = 0                           'key-value string begin-parse position
   do                                        'loop to extract maximum key bytes
      ckeyhgh = ckeyhgh + char(pdqvali(mid$(ca, ichrpos + 1)))'add the key byte
      ichrpos = instr(ichrpos + 1, ca, ",")        'move to next parse position
   loop while ichrpos                 'loop while next parse position available
   line input #iunit, ca                          'header for main header title
   line input #iunit, cdat(0, 0)                             'main header title
   line input #iunit, ca                      'header for ....not found message
   line input #iunit, cdat(0, 2)                  'message: ..........not found
   line input #iunit, ca                         'header for no. of data fields
   line input #iunit, ca                      'no. of data fields (string form)
   bp.fldsav = pdqvali(ca) - 1                    'no. of data fields (numeric)
   bc.fldmax = bp.fldsav - bp.begfld     'set current maximum display field no.
   bc.fldmin = -bp.begfld           'load fields not displayed to (-)subscripts
   for ifldno = bc.fldmin to bc.fldmax          'read all fields in script file
      line input #iunit, ca                'header for title, type, width, etc.
      input #iunit, cdat(2, ifldno)                         'get field title #1
      input #iunit, cdat(3, ifldno)                         'get field title #2
      input #iunit, cdat(4, ifldno)                             'get field type
      input #iunit, ca                               'field width (string form)
      iptr(2, ifldno) = pdqvali(ca)                      'field width (numeric)
      if iptr(2, ifldno) = 0 then                      'field size not declared
         iptr(2, ifldno) = -1                 'set field size to auto-configure
      end if
      input #iunit, ca                       'field Btrieve start (string form)
      iptr(0, ifldno) = pdqvali(ca)              'field Btrieve start (numeric)
      input #iunit, ca                      'field Btrieve length (string form)
      iptr(1, ifldno) = pdqvali(ca)             'field Btrieve length (numeric)
      input #iunit, ca                     'field source file no. (string form)
      iptr(3, ifldno) = pdqvali(ca) - 1        'field source file no. (numeric)
      select case cdat(4, ifldno)                         'select on field type
         case "E1"                                       'expandable-type field
            line input #iunit, ca           'separator characters (with "....")
            cdat(5, ifldno) = mid$(ca, 2, len(ca) - 2)       'remove the quotes
            cdat(6, ifldno) = ""             'initialize segment-lengths buffer
            input #iunit, ca                'no. of segments in expansion field
            for i = 1 to pdqvali(ca)        'loop thru expansion-field segments
               input #iunit, ca                   'segment length (string form)
               cdat(6, ifldno) = cdat(6, ifldno) + char(pdqvali(ca))
            next                         'add segment lengths to buffer [above]
         case "H6", _                                'extension [**] type field
              "H7", _                                'extension [*/] type field
              "H8", _                                'extension [/*] type field
              "H9", _                                'extension [//] type field
              "M6", _                                'extension [**] type field
              "M7", _                                'extension [*/] type field
              "M8", _                                'extension [/*] type field
              "M9"                                   'extension [//] type field
            input #iunit, ca                    'extension field# (string form)
            cdat(5, ifldno) = str$(pdqvali(ca) - 1)      'converted string form
            input #iunit, cdat(6, ifldno)               'get extension constant
         case "S0", _           'replaceable field type (source index base = 0)
              "S1", _           'replaceable field type (source index base = 1)
              "S2", _            'updateable field type (source index base = 0)
              "S3", _            'updateable field type (source index base = 1)
              "S4", _                    'updateable field type (source lookup)
              "S5", _                   'replaceable field type (source lookup)
              "S6"                      'replaceable field type (const. subst.)
            ifldtpn = pdqvali(right$(cdat(4, ifldno), 1))          '0,1,2,3....
            if ifldtpn >= 2 and ifldtpn <= 4 and bp.pginit then'updateable type
               itagfld = ifldno               'set tag-field no. when bp.pginit
            end if
            if ifldtpn >= 4 then                      'source lookup field type
               line input #iunit, ca        'S-type source string (with "....")
               cdat(5, ifldno) = mid$(ca, 2, len(ca) - 2)    'remove the quotes
            end if
            line input #iunit, ca        'S-type selection string (with "....")
            cdat(6, ifldno) = mid$(ca, 2, len(ca) - 2)       'remove the quotes
         case else
      end select
   next
   close iunit                           'close the script (configuration) file
   if cdat(0, 0) <> "" then                  'a main header title was specified
      cdat(0, 0) = " " + cdat(0, 0) + " "   'pad title for display on top line,
   end if                                   '...else title would display in box
   if cdat(0, 2) <> "" then                'a 'not found' message was specified
      cdat(0, 2) = cdat(0, 2) + " not found.  Press any key to return to the menu."
   end if      'fill out 'not found' message [above] and footer message [below]
   cdat(0, 3) = "F9=Print w/sep;  F10=Print no sep;  Ctl-Left=Left;  Ctl-Right=Right"
   ikeylen = len(ckey(0))            'length of first file's Btrieve access key
   ckey(20) = ckeylow + string$(ikeylen - len(ckeylow), 0)    'lowest key value
   ckey(21) = ckeyhgh + string$(ikeylen - len(ckeyhgh), 255) 'highest key value
   for iseg = 0 to iptr(7, 10)                 'loop thru the key-mask segments
      select case mid$(ckey(10), iptr(8, iseg), iptr(8, iseg + 10))
         case "LLLL"                                       'signed long integer
            mid$(ckey(21), iptr(8, iseg)) = char(255) + char(255) _'rebuild the
                                          + char(255) + char(127)  'key segment
         case "II"                                        'signed short integer
            mid$(ckey(21), iptr(8, iseg)) = char(255) + char(127)'rebuild segm.
         case else
      end select
   next
   bc.colmin = -1                        'window start column (-1 = autoconfig)
   bc.rowmin = -1                        'window start row    (-1 = autoconfig)
   bc.rowtot = -1                        'row size of window  (-1 = autoconfig)
   if bp.begfld > 0 then            'NO search-edit if not displaying 1st field
      bc.edtmax = -1                          'set no. of search fields to NONE
   end if
   if bp.pginit then                 'initialization flag is ON (first time in)
      for ifil = 0 to bc.filmax       'loop thru files specified in this browse
         if csec(ifil) <> "" then   'security specifier was found for this file
            lset crcd(0, ifil) = csec(ifil) + char(0)'put security ID to buffer
            ibuflen = len(csec(ifil)) + 1  'set file-open buflen to security ID
         else                       'security specifier not found for this file
            ibuflen = iptr(4, ifil)      'set file-open buflen to actual length
         end if
         if itagfld then                      'a tag (updateable) field was set
            imode = BTRV.NORMAL             'set Btrieve open to update file(s)
         else                             'a tag (updateable) field was not set
            imode = BTRV.RO                      'set Btrieve open to read-only
         end if
         istat = BTRV(BTRV.OPEN, crcd(1, ifil), _  'open specified Btrieve file
         crcd(0, ifil), (ibuflen), cdir + cnam(ifil) + " ", imode)
         if istat then                              'error opening Btrieve file
            i = BTRV(BTRV.RESET, "", "", 0, "", 0)  'call BTRV to perform reset
            i = ifn.msgs("Btrieve error " + ltrim$(str$(istat)) + _
                         " opening " + cnam(ifil), iofs, irow, icol, 1, 1)
         end if                         'display error message [above] and exit
         istat = BTRV(BTRV.STAT, crcd(1, ifil), _     'get STAT on Btrieve file
         crcd(0, ifil), (ibuflen), space$(64), 0)
         if istat then                              'error getting Btrieve STAT
            i = BTRV(BTRV.RESET, "", "", 0, "", 0)  'call BTRV to perform reset
            i = ifn.msgs("Btrieve error " + ltrim$(str$(istat)) + " getting " + _
                         "STAT on " + cnam(ifil), iofs, irow, icol, 1, 1)
         end if                         'display error message [above] and exit
         ivarlen = cvi(mid$(crcd(0, ifil), 11, 2)) and 1  'variable length flag
         if ivarlen = 0 then                          'file NOT variable length
            iptr(4, ifil) = cvi(mid$(crcd(0, ifil), 1, 2)) 'set to fixed length
            crcd(0, ifil) = ""                        'reinitialize file buffer
            crcd(0, ifil) = string$(iptr(4, ifil), 0)    'reset to fixed length
         end if
      next
   end if
end function
