'/* BTRVCOPY.BAS Copy Btrieve source file to Btrieve dest. file */
'/*              By: Dale Thorn                                 */
'/*              Rev. 21.07.2002                                */

'/* ////////////////////////////////////////////////////////
'/* OK to compile with PDQ lib [custom 'dfn.round' function]
'/* \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

'$include: 'basdef.h'
'$include: 'btrieve.h'
'$include: 'filekill.h'
'$include: 'fileopen.h'
'$include: 'longname.h'
'$include: 'messages.h'
'$include: 'midchar.h'
'$include: 'parmstr1.h'
'$include: 'string.h'

declare function ierrproc(cerrmsg, cfilbuf, lerrptr, ierrset, ierrfil, _
                          ibuflen, istatus, imsgdisp, iexit)
declare function ifn.ldfs(cfilnam(), ikeynum(), csegtyp(), isegbeg(), iseglen(), _
                          isegtbl(), csegtxt(), cfldnam(), cfldtyp(), ifldbeg(), _
                          ifldlen(), itblnum(), ifactor(), cfldtxt(), _
                          cfldlst, cddfnam, ifldndx, ifldmax, ifilmax)
declare function io.kget(inop)
declare function io.ktst(inop)

'$include: 'basdef.bas'
'$include: 'btrieve.bas'
'$include: 'filekill.bas'
'$include: 'fileopen.bas'
'$include: 'longname.bas'
'$include: 'messages.bas'
'$include: 'midchar.bas'
'$include: 'parmstr1.bas'
'$include: 'string.bas'

dim cfilnam(9)                               'initialize Btrieve file filenames
dim cfilbuf(9)                            'initialize Btrieve file data buffers
dim ckeybuf(9)                             'initialize Btrieve file key buffers
dim cposblk(9)                         'initialize Btrieve file position blocks
dim ibuflen(9)                          'initialize Btrieve file buffer lengths
dim ikeylen(9)                             'initialize Btrieve file key lengths
dim ikeynum(9)                                  'initialize Btrieve key numbers
dim istatus(9)                                 'initialize Btrieve status codes

dim csegtyp(9, 9)                             'initialize key segment data type
dim isegbeg(9, 9)                            'initialize key segment begin posn.
dim iseglen(9, 9)                            'initialize the key segment length
dim isegtbl(9, 9)                            'initialize the key segment table#
dim csegtxt(9, 9)                          'initialize key segment literal text

dim cfldnam(256, 1)                   'field names for importing/exporting data
dim cfldtyp(256, 1)                   'field types for importing/exporting data
dim ifldbeg(256, 1)                 'field offsets for importing/exporting data
dim ifldlen(256, 1)                 'field lengths for importing/exporting data
dim itblnum(256, 1)                 'table numbers for importing/exporting data
dim ifactor(256, 1)                'factor offsets for importing/exporting data
dim cfldtxt(256, 1)                 'replacement text for existing field values

ccmd = ucase$(rtrim$(command$))         'get the user's command-line parameters
if ccmd = "" then                              'a command line was NOT supplied
   cls                                                'clear the display screen
   print
   cmsg = "Usage:  BTRVCOPY  source  dest                  "
   ctmp = space$(4)                        'initialize the messages left margin
   ipos1 = len(cmsg) - 15                         'position for '/?' parameters
   print ctmp; cmsg
   mid$(cmsg, 1) = "      "
   mid$(cmsg, ipos1) = "/EB (Btrv out)  "
   print ctmp; cmsg
   mid$(cmsg, ipos1) = "/K# (key number)"
   print ctmp; cmsg
   mid$(cmsg, ipos1) = "/KP (phys. seq.)"
   print ctmp; cmsg
   mid$(cmsg, ipos1) = "/C(begin,len)   "
   print ctmp; cmsg
   mid$(cmsg, ipos1) = "/E(begin,len)   "
   print ctmp; cmsg
   mid$(cmsg, ipos1) = "/X(begin,len)   "
   print ctmp; cmsg
   mid$(cmsg, ipos1) = "/D (delete)     "
   print ctmp; cmsg
   mid$(cmsg, ipos1) = "/N (no displays)"
   print ctmp; cmsg
   print
   print ctmp; "If '/EB' specified, the first line of the source/dest. field"
   print ctmp; "scripts must contain the full path plus the Btrieve filename."
   print ctmp; "If '/K#' specified, use Btrieve key number (#: 0 thru 9)."
   print ctmp; "If '/KP' specified, use Btrieve physical record sequence."
   print ctmp; "If '/C' specified, compress all records to eliminate the data"
   print ctmp; "located in the buffer from 'begin' thru 'len' byte positions."
   print ctmp; "If '/E' specified, expand all records to incorporate an empty"
   print ctmp; "field into the buffer from 'begin' thru 'len' byte positions."
   print ctmp; "If '/X' specified, exclude all records from source->dest copy"
   print ctmp; "where buffer is blank from 'begin' thru 'len' byte positions."
   print ctmp; "If '/D' specified, delete records from dest. file before copy."
   print ctmp; "If '/N' specified do not display messages unless errors found."
   print
   print ctmp; "'source' is the source field script filename."
   print ctmp; " 'dest' is the destination script filename.";
   itstkey = io.kget(0)               'freeze 25-line text to prevent scrolling
   close                              'close all files in case not closed above
   system                                   'return control to operating system
end if                              'display the usage message [above] and exit

icomprs = 0                 'initialize flag to NOT compress dest. data records
idelete = 0               'initialize flag to NOT delete records from dest.file
iexclud = 0                 'initialize flag to NOT exclude source data records
iexpand = 0                   'initialize flag to NOT expand dest. data records
iexpbtv = 0                  'initialize flag to convert data in Btrieve format
ikeyseq = 0                'initialize destination key number to normal default
iphyseq = 0                'initialize flag to read source file in key sequence
ipos1 = instr(ccmd, "/EB")             'user selected to export in Btrv.format?
if ipos1 then                          'user selected to export in Btrv.format!
   iexpbtv = not 0                      'set flag to export data in Btrv.format
   ccmd = rtrim$(left$(ccmd, ipos1 - 1) + mid$(ccmd, ipos1 + 3))  'remove '/EB'
end if
ipos1 = instr(ccmd, "/K")              'user selected to change the key access?
if ipos1 then                          'user selected to change the key access!
   ctmp = mid$(ccmd, ipos1 + 2, 1)     'extract key number or physical sequence
   if ctmp = "P" then                  'user selected to read physical sequence
      iphyseq = not 0                   'set the read physical sequence flag ON
   else                                   'user selected to read a key sequence
      ikeyseq = pdqvali(ctmp)                 'set the key# to user's selection
   end if
   ccmd = rtrim$(left$(ccmd, ipos1 - 1) + mid$(ccmd, ipos1 + 3))  'remove '/K#'
end if
ipos1 = instr(ccmd, "/D")                   'pre-delete records from dest.file?
if ipos1 then                               'pre-delete records from dest.file!
   idelete = not 0                        'set flag ON to delete from dest.file
   ccmd = rtrim$(left$(ccmd, ipos1 - 1) + mid$(ccmd, ipos1 + 2))   'remove '/D'
end if
ipos1 = instr(ccmd, "/N")               'don't display (except error) messages?
if ipos1 then                                 'user said don't display messages
   imsgdisp = 0                                'set message display flag to OFF
   ccmd = rtrim$(left$(ccmd, ipos1 - 1) + mid$(ccmd, ipos1 + 2))   'remove '/N'
else                                          'user said OK to display messages
   imsgdisp = not 0                             'set message display flag to ON
end if

iprm = parmstr1(" " + ccmd, "", "", "", cprm())  'parse command-line parameters
if iprm < 1 or iprm > 4 then                      'invalid number of parameters
   i = ifn.msgs("Invalid number of parameters", 5, 24, 79, 1, 1)
end if                                  'display error message [above] and exit
if iprm > 1 then                  'user said to compress/expand/exclude records
   select case left$(cprm(2), 1)      'select on compress/expand/exclude switch
      case "C"                        'user said to compress dest. data records
         icomprs = not 0              'set the compress dest. records switch ON
      case "E"                          'user said to expand dest. data records
         iexpand = not 0                'set the expand dest. records switch ON
      case "X"                         'user said to exclude dest. data records
         iexclud = not 0               'set the exclude dest. records switch ON
      case else                      'invalid compress/expand/exclude parameter
         i = ifn.msgs("Invalid compress/expand/exclude parameter", 5, 24, 79, 1, 1)
   end select                           'display error message [above] and exit
   cprm(2) = ltrim$(mid$(cprm(2), 2))    'remove compress/expand/exclude switch
   for i = 3 to iprm                    'loop thru text-begin and length params
      if cprm(2) = "" then              'cprm(2)==null; don't add leading blank
         cprm(2) = cprm(i)              'add next compress/expand/exclude param.
      else                              'cprm(2)<>null; OK to add leading blank
         cprm(2) = cprm(2) + " " + cprm(i)'add next compr./expand/exclude param.
      end if
   next
   ipos1 = instr(cprm(2), " ")   'position of blank separating begin/len.values
   ipos2 = instr(cprm(2), ",")   'position of comma separating begin/len.values
   if ipos1 < ipos2 then         'comma position is greater than blank position
      ipos1 = ipos2             'set comma position greater than blank position
   end if
   itxtbeg = pdqvali(left$(cprm(2), ipos1))   'get compr./exp./excl.begin value
   itxtlen = pdqvali(mid$(cprm(2), ipos1 + 1)) 'get compr./exp./excl.len. value
   if itxtbeg = 0 or itxtlen = 0 then       'invalid compr./exp./excl.parameter
      i = ifn.msgs("Invalid compress/expand/exclude parameter", 5, 24, 79, 1, 1)
   end if                               'display error message [above] and exit
else                          'user said NOT to compress/expand/exclude records
   itxtbeg = 1              'set the compress/expand/exclude begin value to one
   itxtlen = 0            'set the compress/expand/exclude length value to zero
end if

if iexpbtv then                             'export all records to Btrieve file
   i = ifn.ldfs(cfilnam(), ikeynum(), csegtyp(), isegbeg(), iseglen(), _
                isegtbl(), csegtxt(), cfldnam(), cfldtyp(), ifldbeg(), _
                ifldlen(), itblnum(), ifactor(), cfldtxt(), _
                cprm(0), cdstddfnam, 0, ifldmax, ifilmax)
end if                                      'load the source file specs [above]
if iexpbtv then                             'import all records to Btrieve file
   isavmax = ifldmax                    'save ifldmax before getting dest.specs
   i = ifn.ldfs(cfilnam(), ikeynum(), csegtyp(), isegbeg(), iseglen(), _
                isegtbl(), csegtxt(), cfldnam(), cfldtyp(), ifldbeg(), _
                ifldlen(), itblnum(), ifactor(), cfldtxt(), _
                cprm(1), "", 1, ifldmax, 0)          'load the dest. file specs
   if ifldmax < isavmax then   'source fieldlist file has more fields than dest.
      i = ifn.msgs("Source field spec has no dest. field spec", 5, 24, 79, 1, 1)
   end if
else                             'output records to Btrieve file with NO script
   cfilnam(1) = cprm(0)              'set source file from source path+filename
   cfilnam(0) = cprm(1)                  'set dest.file from dest.path+filename
   ifilmax = 1                         'default max. file index for non-iexpbtv
end if
ilen1 = len(cfilnam(0))                         'get length of Btrieve filename
ipos1 = istr.rcfn(ilen1, cfilnam(0), ".")      'Btrieve file extension position
if ipos1 = 0 then                                 'extension position NOT found
   ipos1 = ilen1 + 1                              'set position to end plus one
end if
ctxtnam = left$(cfilnam(0), ipos1 - 1)   'text filename less filename extension
crtnlnf = char(13) + char(10)         'initialize the carriage-return/line-feed

for i = 1 to ifilmax        'loop thru the total number of source Btrieve files
   ibuflen(i) = 4096         'initialize source buffer length to system maximum
   ikeylen(i) = 128             'initialize source key length to system maximum
   ikeynum(i) = ikeyseq        'set source key number from user/default [above]
   cfilbuf(i) = string$(ibuflen(i), 0)      'initialize source file data buffer
   ckeybuf(i) = string$(ikeylen(i), 0)       'initialize source file key buffer
   cposblk(i) = string$(128, 0)          'initialize source file position block
   istatus(i) = BTRV(BTRV.OPEN, cposblk(i), cfilbuf(i), _
                     (ibuflen(i)), cfilnam(i) + " ", BTRV.RO) 'open source file
   if istatus(i) then                                'error opening source file
      i = ierrproc(" opening " + cfilnam(i), "", 0, 0, 0, 0, _
                   istatus(i), imsgdisp, 1)
   end if                               'display error message [above] and exit
   istatus(i) = BTRV(BTRV.STAT, cposblk(i), cfilbuf(i), _
                     (ibuflen(i)), ckeybuf(i), 0)   'get the source file status
   if istatus(i) then                         'error getting source file status
      i = ierrproc(" getting STAT from " + cfilnam(i), "", 0, 0, 0, 0, _
                   istatus(i), imsgdisp, 1)
   end if                               'display error message [above] and exit
   if cvi(mid$(cfilbuf(i), 11, 2)) mod 2 then   'source file is variable-length
      ibuflen(i) = cvi(mid$(cfilbuf(i), 3, 2))  'set record length to page size
   else                                        'source file NOT variable-length
      ibuflen(i) = cvi(mid$(cfilbuf(i), 1, 2))  'set record length=fixed length
      cfilbuf(i) = ""                          'reinitialize source file buffer
      cfilbuf(i) = string$(ibuflen(i), 0)     'set buffer length to STAT length
   end if
next

ibuflen(0) = 4096       'initialize destination buffer length to system maximum
ikeylen(0) = 128           'initialize destination key length to system maximum
ikeynum(0) = ikeyseq      'set destination key number from user/default [above]
cfilbuf(0) = string$(ibuflen(0), 0)    'initialize destination file data buffer
ckeybuf(0) = string$(ikeylen(0), 0)     'initialize destination file key buffer
cposblk(0) = string$(128, 0)        'initialize destination file position block

istatus(0) = BTRV(BTRV.OPEN, cposblk(0), cfilbuf(0), _      'open the dest.file
                  (ibuflen(0)), cfilnam(0) + " ", BTRV.NORMAL)
if istatus(0) then                          'error opening the destination file
   i = ierrproc(" opening " + cfilnam(0), "", 0, 0, 0, 0, _
                istatus(0), imsgdisp, 1)
end if                                  'display error message [above] and exit
istatus(0) = BTRV(BTRV.STAT, cposblk(0), cfilbuf(0), _
                  (ibuflen(0)), ckeybuf(0), 0)     'get destination file status
if istatus(0) then                              'error getting dest.file status
   i = ierrproc(" getting STAT from " + cfilnam(0), "", 0, 0, 0, 0, _
                istatus(0), imsgdisp, 1)
end if                                  'display error message [above] and exit
if cvi(mid$(cfilbuf(0), 11, 2)) mod 2 then     'Btrieve file is variable-length
   ibuflen(0) = cvi(mid$(cfilbuf(0), 3, 2))     'set record length to page size
   idstvarlen = not 0                           'set variable-length flag to ON
else                                          'Btrieve file NOT variable-length
   ibuflen(0) = cvi(mid$(cfilbuf(0), 1, 2))     'set record length=fixed length
   cfilbuf(0) = ""                            'reinitialize Btrieve file buffer
   cfilbuf(0) = string$(ibuflen(0), 0)        'set buffer length to STAT length
   idstvarlen = 0                              'set variable-length flag to OFF
end if

lerrptr = 1                           'initialize the error-output file pointer
ierrset = 0                            'initialize the error-output file status
ierrfil = freefile                     'initialize the error-output file number
i = ifn.kill(ierrfil, ctxtnam + ".err")    'kill any previous error-output file
open ctxtnam + ".err" for binary as ierrfil  'open error file for binary access

if idelete then              'OK to delete records from dest.file before adding
   i = ifn.msgs("Deleting from " + cfilnam(0), 5, 24, 79, 0, 0)  'standby' msg.
   itmpbuflen = ibuflen(0)            'make copy so Btrieve can't change buflen
   istatus(0) = BTRV(BTRV.GETLO, cposblk(0), cfilbuf(0), _
                     itmpbuflen, ckeybuf(0), ikeynum(0))      'get first record
   while istatus(0) = 0           'loop while records found in destination file
      istatus(0) = BTRV(BTRV.DELETE, cposblk(0), cfilbuf(0), _
                        itmpbuflen, ckeybuf(0), ikeynum(0))  'delete the record
      if istatus(0) then            'unexpected error deleting dest.file record
         i = ierrproc(" deleting record from " + cfilnam(0), cfilbuf(0), lerrptr, _
                      ierrset, ierrfil, itmpbuflen, istatus(0), imsgdisp, 1)
      elseif io.ktst(0) = 27 then                     'user pressed the ESC key
         i = BTRV(BTRV.RESET, "", "", 0, "", 0)        'close all Btrieve files
         i = ifn.msgs("ESC selected - program aborted", 5, 24, 79, 0, 1)
      end if                        'display the abort message [above] and exit
      itmpbuflen = ibuflen(0)         'make copy so Btrieve can't change buflen
      istatus(0) = BTRV(BTRV.GETNEXT, cposblk(0), cfilbuf(0), _
                        itmpbuflen, ckeybuf(0), ikeynum(0))
   wend                          'get next record from destination file [above]
   if istatus(0) <> BTRV.EOF then        'unexpected error getting first record
      i = ierrproc(" getting record from " + cfilnam(0), "", 0, ierrset, 0, 0, _
                   istatus(0), imsgdisp, 1)
   end if                               'display error message [above] and exit
end if

if imsgdisp then                              'user said OK to display messages
   i = ifn.msgs("Copying " + cfilnam(1), 5, 24, 79, 0, 0)    'OK to proceed....
end if

if iphyseq then                      'read the source file in physical sequence
   ibtrvop = BTRV.STEPFIRST          'get the first record in physical sequence
else                                  'read the source file in key no. sequence
   ibtrvop = BTRV.GETLO               'get the first record in key no. sequence
end if
itmpbuflen = ibuflen(1)               'make copy so Btrieve can't change buflen
istatus(1) = BTRV(ibtrvop, cposblk(1), cfilbuf(1), _
                  itmpbuflen, ckeybuf(1), ikeynum(1))  'get first source record
lrecordatt = 0                       'initialize the 'nnn records read' counter
lrecordcnt = 0                     'initialize the 'nnn records copied' counter
while istatus(1) = 0 or istatus(1) = 22 'loop until we're at end of source file
   lrecordatt = lrecordatt + 1            'increment 'nnn records read' counter
   if iexclud = 0 or cstr.trim(mid$(cfilbuf(1), itxtbeg, itxtlen)) <> "" then
      ctmpfilbuf = left$(cfilbuf(1), itmpbuflen)'make temp.copy of source buffer
      if idstvarlen then                   'destination file is variable-length
         itmpbuflen = len(rtrim$(ctmpfilbuf))'set dest.buflen to trimmed length
         if itmpbuflen < ibuflen(0) then      'trimmed length is < fixed length
            itmpbuflen = ibuflen(0)            'set dest.buflen to fixed length
         end if
      else                             'destination file is NOT variable-length
         itmpbuflen = ibuflen(0)      'make copy so Btrieve can't change buflen
      end if
      if iexpbtv then                       'output user data in Btrieve format
         for ifilndx = 2 to ifilmax         'loop thru the source Btrieve files
            isegpos = 1                      'initialize position in target key
            for isegndx = 0 to 9               'loop thru possible key segments
               if csegtyp(ifilndx, isegndx) = "" then  'end of all key segments
                  exit for                      'end of key segments; exit loop
               end if
               if isegbeg(ifilndx, isegndx) then 'get key data from source file
                  mid$(ckeybuf(ifilndx), isegpos) = _
                  mid$(cfilbuf(isegtbl(ifilndx, isegndx)), _
                       isegbeg(ifilndx, isegndx), _
                       iseglen(ifilndx, isegndx))  'load key data f/source file
                  csavkey = _
                  left$(ckeybuf(ifilndx), _
                        isegpos + iseglen(ifilndx, isegndx) - 1) 'save curr.key
               else           'no key data in source; set segment to text value
                  csegval = csegtxt(ifilndx, isegndx) 'make temp.copy of keyseg
                  i = istr.fmti(csegval, csegtyp(ifilndx, isegndx), _
                                iseglen(ifilndx, isegndx))'internal data format
                  mid$(ckeybuf(ifilndx), isegpos) = csegval 'field data->buffer
                  if isegndx = 0 then        'first key segment is literal text
                     csavkey = _
                     left$(ckeybuf(ifilndx), _
                           isegpos + iseglen(ifilndx, isegndx) - 1)
                  end if                     'save the current key data [above]
               end if
               isegpos = isegpos + iseglen(ifilndx, isegndx) 'incr.segment posn.
            next
            ibtrvop = BTRV.GETGE        'get first record matching key segments
            istatus(ifilndx) = BTRV(ibtrvop, cposblk(ifilndx), cfilbuf(ifilndx), _
                                    ibuflen(ifilndx), ckeybuf(ifilndx), _
                                    ikeynum(ifilndx))'load the join-file record
            if left$(ckeybuf(ifilndx), len(csavkey)) <> csavkey _
            or istatus(ifilndx) <> 0 then    'join-file load was NOT successful
               lset cfilbuf(ifilndx) = string$(ibuflen(ifilndx), 0)'clear buffer
            end if
         next
         for ifldndx = 0 to ifldmax             'loop thru the fieldlist fields
            '
            ' Set factor, use factor, skip field if blank or zero logic:
            ' (Note that these are "bit" values, added to the total)
            '   0 = No factor, no test, no skip.                 [all bits OFF]
            '   1 = Set factor from current field value.         [Bit #0 is ON]
            '   2 = Set test #1 from current field value.        [Bit #1 is ON]
            '   4 = Set test #2 from current field value.        [Bit #2 is ON]
            '   8 = Set test #2 from current constant data.      [Bit #3 is ON]
            '  16 = Use saved factor on current field data.      [Bit #4 is ON]
            '  32 = Use saved factor only if match on tests.     [Bit #5 is ON]
            '  64 = Update current field only if match on tests. [Bit #6 is ON]
            ' 128 = Don't update current field if blank or zero. [Bit #7 is ON]
            ' 256 = Don't update field (test1/test2/factor only).[Bit #8 is ON]
            '
            if ifactor(ifldndx, 0) and 16 then 'current field uses factor value
               ctmpval = cfactor             'set field text #1 to factor value
            elseif ifactor(ifldndx, 0) and 32 then'use factor only if test match
               if ctstval1 = ctstval2 then      'OK to use factor - tests match
                  ctmpval = cfactor          'set field text #1 to factor value
               else                      'do NOT use factor - tests don't match
                  ctmpval = ""                    'set field text to empty/null
               end if
            else                       'current field does NOT use factor value
               ctmpval = cfldtxt(ifldndx, 0)  'set field text #1 to normal text
            end if
            if cfldnam(ifldndx, 0) <> "" then      'field exists in source file
               if ifldbeg(ifldndx, 0) > 0 then    'output field has source data
                  cfldval = mid$(cfilbuf(itblnum(ifldndx, 0)), _
                                         ifldbeg(ifldndx, 0), _
                                         ifldlen(ifldndx, 0))'source field data
               else                            'output field has NO source data
                  if cfldtxt(ifldndx, 1) <> "" then 'a constant value was given
                     cfldval = cfldtxt(ifldndx, 1)'set output value to constant
                  else                          'a constant value was NOT given
                     cfldval = string$(ifldlen(ifldndx, 0), 0)'source field data
                  end if
               end if
               if ifactor(ifldndx, 0) and 48 then  'use factor value specified!
                  dfactor = val(ctmpval)           'factor value (numeric form)
               else                                 'factor value NOT specified
                  dfactor = 0                         'set factor value to zero
               end if
               i = istr.fmtx(cfldval, cfldtyp(ifldndx, 0), dfactor, 0)
               if cfldtxt(ifldndx, 1) <> "" then  'replacement-string specified
                  ilen1 = ifldlen(ifldndx, 0)      'length of source field/item
                  icount = len(ctmpval) \ ilen1     'total of replacement items
                  ilen2 = len(cfldtxt(ifldndx, 1)) \ icount 'replacement length
                  for i = 1 to icount              'loop thru replacement items
                     ipos1 = (i - 1) * ilen1 + 1       'position of source item
                     ipos2 = (i - 1) * ilen2 + 1  'position of replacement item
                     if cfldval = rtrim$(mid$(ctmpval, ipos1, ilen1)) then'match
                        cfldval = rtrim$(mid$(cfldtxt(ifldndx, 1), ipos2, ilen2))
                        exit for     'replace field value [above] and exit loop
                     end if
                  next
               end if
               if ifactor(ifldndx, 0) and 1 then 'current field is factor value
                  cfactor = cfldval              'save the current factor value
               end if
               if ifactor(ifldndx, 0) and 2 then   'curr.field is test value #1
                  ctstval1 = cfldval                        'save test value #1
               end if
               if ifactor(ifldndx, 0) and 12 then   'curr.field==test value 1/2
                  ctstval2 = cfldval                    'save test value 1 or 2
               end if
            else                           'field does NOT exist in source file
               cfldval = ""                    'set test#1 value to null string
               ctstval1 = ""                   'set test#2 value to null string
               ctstval2 = ""                   'set output value to null string
            end if
            if ifactor(ifldndx, 0) and 192 then   'conditional update in effect
               iupdate = 0                 'preset the field update flag to OFF
               if ifactor(ifldndx, 0) and 64 then'write data only if test match
                  if ctstval1 = ctstval2 then       'OK to update - tests match
                     iupdate = not 0                'update OK - set flag to ON
                  end if
               end if
               if ifactor(ifldndx, 0) and 128 then   'don't write data if blank
                  if cfldtyp(ifldndx, 0) <> "S" and cfldval <> "0" _  'non-zero
                  or cfldtyp(ifldndx, 0) = "S" and cfldval <> "" then'non-blank
                     iupdate = not 0                'update OK - set flag to ON
                  end if
               end if
            elseif (ifactor(ifldndx, 0) and 256) = 0 then   'OK to update field
               iupdate = not 0                      'update OK - set flag to ON
            end if
            if iupdate then                'OK to update the current field data
               i = istr.fmti(cfldval, cfldtyp(ifldndx, 1), ifldlen(ifldndx, 1))
               mid$(cfilbuf(0), ifldbeg(ifldndx, 1)) = cfldval'put data->buffer
            end if               'format and write the input field data [above]
         next
         istatus(0) = BTRV(BTRV.INSERT, cposblk(0), cfilbuf(0), _
                           itmpbuflen, ckeybuf(0), ikeynum(0))   'insert record
      else                                  'output all records to Btrieve file
         lset cfilbuf(0) = ctmpfilbuf         'put source to destination buffer
         if icomprs then                   'user said to compress dest. records
            mid$(cfilbuf(0), itxtbeg) = mid$(cfilbuf(0), itxtbeg + itxtlen) + _
                                        space$(itxtlen)  'remove selected field
         elseif iexpand then                 'user said to expand dest. records
            mid$(cfilbuf(0), itxtbeg) = space$(itxtlen) + mid$(cfilbuf(0), itxtbeg)
         end if                          'expand the destination record [above]
         istatus(0) = BTRV(BTRV.INSERT, cposblk(0), cfilbuf(0), _
                           itmpbuflen, ckeybuf(0), ikeynum(0))   'insert record
      end if
      if istatus(0) then           'duplicates error inserting dest.file record
         isaverr = ierrset      'save previous error status for first-time test
         i = ierrproc(" inserting record into " + cfilnam(0), cfilbuf(0), lerrptr, _
                      ierrset, ierrfil, itmpbuflen, istatus(0), imsgdisp, 0)
         if (not isaverr) and imsgdisp then'error message hasn't been displayed
            locate 7, 5, 0       'locate cursor and display 2nd message [below]
            print "Press any key to continue or press ESC to exit"
            itstkey = io.kget(0)   'get user's response to error message/prompt
            if itstkey = 27 then                      'user pressed the ESC key
               i = BTRV(BTRV.RESET, "", "", 0, "", 0)  'close all Btrieve files
               i = ifn.msgs("ESC selected - program aborted", 5, 24, 79, 0, 1)
            else                                'user did NOT press the ESC key
               i = ifn.msgs("Copying " + cfilnam(1), 5, 24, 79, 0, 0)
               locate 7, 5, 1     'locate cursor for 'nnn records read' counter
               print right$("      " + str$(lrecordatt), 7); " records read"
               locate 9, 5, 1   'locate cursor for 'nnn records copied' counter
               print right$("      " + str$(lrecordcnt), 7); " records copied"
               locate 24, 79, 0                       'hide' the display cursor
            end if
         end if
      elseif io.ktst(0) = 27 then                     'user pressed the ESC key
         i = BTRV(BTRV.RESET, "", "", 0, "", 0)        'close all Btrieve files
         i = ifn.msgs("ESC selected - program aborted", 5, 24, 79, 0, 1)
      else               'record inserted OK and user did NOT press the ESC key
         lrecordcnt = lrecordcnt + 1    'increment 'nnn records copied' counter
      end if
   end if
   if (lrecordatt mod 100 = 0) and imsgdisp then '#records is a multiple of 100
      locate 7, 5, 1              'locate cursor for 'nnn records read' counter
      print right$("      " + str$(lrecordatt), 7); " records read"
      locate 9, 5, 1            'locate cursor for 'nnn records copied' counter
      print right$("      " + str$(lrecordcnt), 7); " records copied"
      locate 24, 79, 0                                'hide' the display cursor
   end if
   if iphyseq then                   'read the source file in physical sequence
      ibtrvop = BTRV.STEPNEXT         'get the next record in physical sequence
   else                               'read the source file in key no. sequence
      ibtrvop = BTRV.GETNEXT           'get the next record in key no. sequence
   end if
   itmpbuflen = ibuflen(1)            'make copy so Btrieve can't change buflen
   istatus(1) = BTRV(ibtrvop, cposblk(1), cfilbuf(1), _
                     itmpbuflen, ckeybuf(1), ikeynum(1))
wend                                  'get next record from source file [above]
if istatus(1) <> BTRV.EOF then           'unexpected error getting first record
   i = ierrproc(" getting record from " + cfilnam(1), "", 0, ierrset, 0, 0, _
                istatus(1), imsgdisp, 1)
end if                                  'display error message [above] and exit

if imsgdisp then                              'user said OK to display messages
   i = ifn.msgs("Copy completed", 5, 24, 79, 0, 0) 'display 'completed' message
   locate 7, 5, 1                 'locate cursor for 'nnn records read' counter
   print right$("      " + str$(lrecordatt), 7); " records read"
   locate 9, 5, 1               'locate cursor for 'nnn records copied' counter
   print right$("      " + str$(lrecordcnt), 7); " records copied"
   if ierrset then                            'error-output file status was set
      locate 11, 5, 1                          'locate cursor for error message
      print "Error records are located in the '"; ctxtnam; ".err' file"
   end if
end if
i = BTRV(BTRV.RESET, "", "", 0, "", 0)            'close all open Btrieve files
close                                              'close all non-Btrieve files
system                                              'return to operating system

function ierrproc(cerrmsg, cfilbuf, lerrptr, ierrset, ierrfil, _
                  ibuflen, istatus, imsgdisp, iexit)    'process error messages
   if lerrptr then                           'OK to write record to output file
      coutlen = ltrim$(str$(ibuflen))          'length of output Btrieve buffer
      coutbuf = coutlen + "," + left$(cfilbuf, ibuflen) + char(13) + char(10)
      put ierrfil, lerrptr, coutbuf                'write record to output file
      lerrptr = lerrptr + len(coutbuf)            'increment error file pointer
   end if
   if (not ierrset) and imsgdisp then 'error message has NOT yet been displayed
      i = ifn.msgs("Error " + ltrim$(str$(istatus)) + cerrmsg, 5, 24, 79, 1, 0)
      if lerrptr then                  'error record was written to output file
         ierrset = not 0               'error record written; set error flag ON
      end if
   end if
   if iexit then                              'OK to return to operating system
      if ierrset then                         'error-output file status was set
         locate 7, 5, 1                        'locate cursor for error message
         print "Error records are located in the matching '.err' file"
      else                                    'error-output file status NOT set
         locate 6, 1, 1                       'locate cursor for exit to system
      end if
      if istatus <> BTRV.ERR then           'status != Btrieve-not-loaded error
         i = BTRV(BTRV.RESET, "", "", 0, "", 0)   'close all open Btrieve files
      end if
      close                                        'close all non-Btrieve files
      system                                        'return to operating system
   end if
end function

function ifn.ldfs(cfilnam(), ikeynum(), csegtyp(), isegbeg(), iseglen(), _
                  isegtbl(), csegtxt(), cfldnam(), cfldtyp(), ifldbeg(), _
                  ifldlen(), itblnum(), ifactor(), cfldtxt(), _
                  cfldlst, cddfnam, ifldndx, ifldmax, ifilmax) 'load fieldspecs
   ifil = freefile                              'get next available file handle
   i = ifn.open(ifil, cfldlst, "S", llof)        'open the field list spec file
   if llof = 0 then                            'field list nonexistent or empty
      i = ifn.kill(ifil, cfldlst)              'kill the zero-length field file
      i = ifn.msgs("'" + cfldlst + "' file not found", 5, 24, 79, 1, 1)
   end if                               'display error message [above] and exit
   if ifldndx = 0 then                  'current index is the source file index
      ifilmax = 0                        'initialize the source filenames index
   else                                  'current index is the dest. file index
      ifilmax = -1                         'initialize the dest. filename index
   end if
   cddfnam = ""                         'initialize the DDF (if appl.) filename
   do                                   'loop thru the filenames and fieldspecs
      if eof(ifil) then                  'we're at EOF (no fieldspecs possible)
         i = ifn.msgs("No fieldspecs in '" + cfldlst + "' file", 5, 24, 79, 1, 1)
      end if               'no fieldspecs found; display error [above] and exit
      line input #ifil, clin            'get next filename (or first fieldspec)
      clin = ltrim$(rtrim$(clin))       'trim the filename/first fieldspec line
      ipos1 = instr(clin, ",")           'comma following filename or fieldname
      if ipos1 then                      'comma found; possible fieldspec found
         if mid$(clin, ipos1 + 1, 1) >= "A" then 'fieldspec line (NOT filename)
            if cddfnam = "" then             'a filename has NOT been specified
               i = ifn.msgs("No filename in '" + cfldlst + "' file", 5, 24, 79, 1, 1)
            end if                      'display error message [above] and exit
            exit do                       'first fieldspec was found; exit loop
         end if
      elseif clin = "" and cddfnam <> "" then 'first fieldspec blank; exit loop
         exit do                              'first fieldspec blank; exit loop
      else                                 'comma NOT found; filename only line
         ipos1 = len(clin) + 1                'set the end-of-filename position
      end if
      ctmp1 = rtrim$(left$(clin, ipos1 - 1))   'get the possible valid filename
      if ctmp1 <> "" then                   'valid filename found; process line
         ifilmax = ifilmax + 1              'increment index for valid filename
         cfilnam(ifilmax) = ctmp1           'store filename into filename array
         if cddfnam = "" then              'DDF filename (if appl.) not set yet
            cddfnam = cfilnam(ifilmax)    'actual filename (or .DDF table name)
         end if
         ikeynum(ifilmax) = pdqvali(mid$(clin, ipos1 + 1))'get keynum from line
         ipos1 = instr(ipos1 + 1, clin, ",")   'move position to join-key specs
         isegndx = -1                  'initialize index for join-file keyspecs
         do while ifilmax > 1            'loop thru possible join-file keyspecs
            ipos2 = instr(ipos1 + 1, clin, ",") '2nd separator position in line
            ipos3 = instr(ipos2 + 1, clin, ",") '3rd separator position in line
            ipos4 = instr(ipos3 + 1, clin, ",") '4th separator position in line
            if ipos2 = 0 or ipos3 = 0 or ipos4 = 0 then 'NOT a complete keyspec
               if isegndx = -1 then              'first join-key spec. for file
                  i = ifn.msgs("No keyspecs for '" + cfilnam(ifilmax) + "' file", _
                               5, 24, 79, 1, 1)
               end if                   'display error message [above] and exit
               exit do                 'no additional join-key specs; exit loop
            end if
            ipos5 = instr(ipos4 + 1, clin, ",") '5th separator position in line
            if ipos5 = 0 then                 'last keyspec - no trailing comma
               ipos5 = len(clin) + 1          'set position to end of text line
            end if
            isegndx = isegndx + 1           'increment join-file keyspecs index
            csegtyp(ifilmax, isegndx) = _                     'key segment type
               ltrim$(rtrim$(mid$(clin, ipos1 + 1, ipos2 - ipos1 - 1)))
            isegbeg(ifilmax, isegndx) = pdqvali(mid$(clin, ipos2 + 1))'seg.begin
            iseglen(ifilmax, isegndx) = pdqvali(mid$(clin, ipos3 + 1))'seg. len.
            ctmp1 = ltrim$(rtrim$(mid$(clin, ipos4 + 1, ipos5 - ipos4 - 1)))
            if left$(ctmp1, 1) <> char(34) or right$(ctmp1, 1) <> char(34) _
            or len(ctmp1) < 3 then        'segment table no. (NOT segment text)
               isegtbl(ifilmax, isegndx) = pdqvali(ctmp1) 'set segment table no.
            else                          'segment text (NOT segment table no.)
               csegtxt(ifilmax, isegndx) = mid$(ctmp1, 2, len(ctmp1) - 2)
               isegbeg(ifilmax, isegndx) = 0      'set to zero (!just in case!)
            end if                     'remove quotes from segment text [above]
            ipos1 = ipos5           'set begin position for next loop iteration
         loop
      end if
   loop
   ifldmax = -1                         'initialize maximum no.of output fields
   do                                   'loop until end of field list spec file
      ifldmax = ifldmax + 1              'increment maximum no.of output fields
      if clin <> "" then                   'current fieldspec line is NOT blank
         ipos1 = instr(clin, ",")            '1st separator posn. in field line
         ipos2 = instr(ipos1 + 1, clin, ",") '2nd separator posn. in field line
         ipos3 = instr(ipos2 + 1, clin, ",") '3rd separator posn. in field line
         ipos4 = instr(ipos3 + 1, clin, ",") '4th separator posn. in field line
         if ipos2 = 0 or ipos3 = 0 or ipos4 = 0 then'separator posn's NOT found
            i = ifn.msgs("Invalid fieldspec in '" + cfldlst + "' file", _
                         5, 24, 79, 1, 1)       'display error message and exit
         end if
         ipos5 = instr(ipos4 + 1, clin, ",") '5th separator posn. in field line
         if ipos5 then                       '5th separator position was found!
            ipos6 = instr(ipos5 + 1, clin, ",") '6th separator position in line
         else                                '5th separator position NOT found!
            ipos6 = 0                       'set 6th separator position to zero
         end if
         cfldnam(ifldmax, ifldndx) = ltrim$(rtrim$(left$(clin, ipos1 - 1)))
         cfldtyp(ifldmax, ifldndx) = _
            ltrim$(rtrim$(mid$(clin, ipos1 + 1, ipos2 - ipos1 - 1)))'field type
         ifldbeg(ifldmax, ifldndx) = pdqvali(mid$(clin, ipos2 + 1))'field offset
         ifldlen(ifldmax, ifldndx) = pdqvali(mid$(clin, ipos3 + 1))'field length
         itblnum(ifldmax, ifldndx) = pdqvali(mid$(clin, ipos4 + 1))'table number
         if ipos6 then      'constant value or replacement-string was specified
            ctmp1 = ltrim$(rtrim$(mid$(clin, ipos5 + 1, ipos6 - ipos5 - 1)))
            if ctmp1 = "" or ctmp1 = "8" or ctmp1 = "264" then  'constant field
               ifactor(ifldmax, ifldndx) = pdqvali(ctmp1)    'factor value flag
               ifldbeg(ifldmax, ifldndx) = 0      'set to zero (!just in case!)
            else                   'replacement string (NOT constant) specified
               if left$(ctmp1, 1) <> char(34) or right$(ctmp1, 1) <> char(34) _
               or len(ctmp1) < 3 then           'error: source string NOT valid
                  i = ifn.msgs("Invalid fieldspec in '" + cfldlst + "' file", _
                               5, 24, 79, 1, 1) 'display error message and exit
               end if
               cfldtxt(ifldmax, 0) = mid$(ctmp1, 2, len(ctmp1) - 2)'copy->array
            end if
            ctmp2 = ltrim$(rtrim$(mid$(clin, ipos6 + 1))) 'constant/replacement
            if left$(ctmp2, 1) <> char(34) or right$(ctmp2, 1) <> char(34) _
            or len(ctmp2) < 3 then    'constant or replacement string NOT valid
               i = ifn.msgs("Invalid fieldspec in '" + cfldlst + "' file", _
                            5, 24, 79, 1, 1)    'display error message and exit
            end if
            cfldtxt(ifldmax, 1) = mid$(ctmp2, 2, len(ctmp2) - 2) 'copy to array
         elseif ipos5 then                        'a factor value was specified
            ctmp1 = ltrim$(rtrim$(mid$(clin, ipos5 + 1)))    'factor value flag
            ifactor(ifldmax, ifldndx) = pdqvali(ctmp1)       'factor value flag
         end if
      end if
      if eof(ifil) then               'we're EOF (no more fieldspecs available)
         exit do                       'no more fieldspecs available; exit loop
      end if
      line input #ifil, clin           'get next line from field list spec file
      clin = ltrim$(rtrim$(clin))       'trim the filename/first fieldspec line
   loop
   close ifil                                   'close the field list spec file
end function

function io.kget(inop)                       'strip key buffer and wait for key
   while inkey$ <> ""                           'begin loop to strip key buffer
   wend                                   'loop while key buffer contains a key
   do                                                               'begin loop
      ckey = inkey$                                    'get key from key buffer
   loop while ckey = ""                                'loop until a key is hit
   if asc(ckey) then                                   'key value in first byte
      io.kget = asc(ckey)                  'return key value to calling program
   else                                            'zero value ("extended" key)
      io.kget = asc(mid$(ckey, 2)) + 128       'return 2nd byte of key plus 128
   end if
end function

function io.ktst(inop)                               'return last key (no wait)
   ckey = inkey$                                       'get key from key buffer
   if ckey <> "" then                                'key buffer contains a key
      if asc(ckey) then                                'key value in first byte
         io.ktst = asc(ckey)                               'key value to return
      else                                         'zero value ("extended" key)
         io.ktst = asc(mid$(ckey, 2)) + 128    'return 2nd byte of key plus 128
      end if
   else                                      'key buffer does NOT contain a key
      io.ktst = 0                                 'set return key value to zero
   end if
end function
