'/* BTRVFCRE.BAS  21.06.1999 */

function io.btrvfcre(csrc, cdst)                         'create a Btrieve file
   cbuf = string$(1024, 0)                        'main buffer for Btrieve file
   cfcb = string$(128, 0)                  'file control block for Btrieve file
   ialtseq = 0                       'alt. collating sequence initialized FALSE
   ibufptr = 16                  'index-pointer for main buffer in Btrieve file
   ikeynum = -1                         'current key no. in Btrieve file-create

   ifno = freefile                       'get next available file channel/unit#
   open csrc for input as ifno                       'open the description file
   do while not eof(ifno)                'do while not EOF in create-table file
      line input #ifno, cdat                              'read first data line
      iptr = istr.lcsp(1, cdat, " ")             'set iptr to beginning of cdat
      select case mid$(cdat, iptr, 1)           'line-type in create-table file
         case "F"                      '"FILE" data line from create-table file
            iptr = istr.lcsp(istr.lcfn(iptr, cdat, " "), cdat, " ") 'filelength
            mid$(cbuf, 1) = mki$(pdqvali(mid$(cdat, iptr, 4)))   'write filelen
            iptr = istr.lcsp(istr.lcfn(iptr, cdat, " "), cdat, " ") 'var.length
            if char(midchar(cdat, iptr)) = "Y" then      'variable-len file=YES
               mid$(cbuf, 11) = mki$(3)          'write value to Btrieve buffer
            end if       'specify "blank truncation" with var.-len code [above]
            iptr = istr.lcsp(istr.lcfn(iptr, cdat, " "), cdat, " ")  'page size
            mid$(cbuf, 3) = mki$(pdqvali(mid$(cdat, iptr, 4)))  'write pagesize
         case "K"                       '"KEY" data line from create-table file
            iptr = istr.lcsp(istr.lcfn(iptr, cdat, " "), cdat, " ") 'key number
            if ikeynum <> pdqvali(mid$(cdat, iptr, 3)) then      'compare key#s
               ikeynum = ikeynum + 1        'val.<>current key#; increment key#
            end if
            iptr = istr.lcsp(istr.lcfn(iptr, cdat, " "), cdat, " ")'segment no.
            if pdqvali(mid$(cdat, iptr, 3)) then    'seg# >0; read bitsum below
               ibitsum = cvi(mid$(cbuf, ibufptr - 11, 2)) + BTRV.SEG
               mid$(cbuf, ibufptr - 11) = mki$(ibitsum)     'rewrite the bitsum
            end if
            ibitsum = 256                        'reset bitsum for current key#
            iptr = istr.lcsp(istr.lcfn(iptr, cdat, " "), cdat, " ")  'recordpos
            mid$(cbuf, ibufptr + 1) = mki$(pdqvali(mid$(cdat, iptr, 4)))
            iptr = istr.lcsp(istr.lcfn(iptr, cdat, " "), cdat, " ") 'segmentlen
            mid$(cbuf, ibufptr + 3) = mki$(pdqvali(mid$(cdat, iptr, 3)))
            iptr = istr.lcsp(istr.lcfn(iptr, cdat, " "), cdat, " ") 'dupl. flag
            if char(midchar(cdat, iptr)) = "Y" then       'duplicatable key=YES
               ibitsum = ibitsum + BTRV.DUP        'add dupl-key flag to bitsum
            end if
            iptr = istr.lcsp(istr.lcfn(iptr, cdat, " "), cdat, " ") 'modi. flag
            if char(midchar(cdat, iptr)) = "Y" then         'modifiable key=YES
               ibitsum = ibitsum + BTRV.MOD        'add modi-key flag to bitsum
            end if
            iptr = istr.lcsp(istr.lcfn(iptr, cdat, " "), cdat, " ")'alt-collat.
            if char(midchar(cdat, iptr)) = "Y" then      'alt-coll.seq. seg=YES
               ibitsum = ibitsum + BTRV.ALT        'add alt-coll.flag to bitsum
               ialtseq = not 0             'set alt-collating program flag TRUE
            end if
            iptr = istr.lcsp(istr.lcfn(iptr, cdat, " "), cdat, " ") 'segm. type
            if char(midchar(cdat, iptr)) = "-" then 'descending segm. specified
               ibitsum = ibitsum + BTRV.DES      'add descending flag to bitsum
               iptr = iptr + 1               'move pointer to segment-type byte
            end if
            select case char(midchar(cdat, iptr))     'select extended key type
               case "A"                              'Autoincrement key segment
                  ichr = 15                         'set the extended key value
               case "B"                            'BASIC MBF float key segment
                  ichr = 9                          'set the extended key value
               case "D"                               'Btrieve date key segment
                  ichr = 3                          'set the extended key value
               case "F"                                 'IEEE float key segment
                  ichr = 2                          'set the extended key value
               case "I", "L"                    'short/long integer key segment
                  ichr = 1                          'set the extended key value
               case "S"                                     'string key segment
                  ichr = 0                          'set the extended key value
               case "T"                               'Btrieve time key segment
                  ichr = 4                          'set the extended key value
               case "U", "W"               'short/long unsigned int key segment
                  ichr = 14                         'set the extended key value
               case else
            end select
            mid$(cbuf, ibufptr + 11) = char(ichr) 'write the extended key value
            iptr = istr.lcsp(istr.lcfn(iptr, cdat, " "), cdat, " ")  'null type
            if  midchar(cdat, iptr) >= 48 _         'null value 1st byte is 0-3
            and midchar(cdat, iptr) <= 51 then           'NULL key values = YES
               ibitsum = ibitsum + BTRV.NUL        'add NULL-key flag to bitsum
               mid$(cbuf, ibufptr + 12) = char(pdqvali(mid$(cdat, iptr, 3)))
            end if
            mid$(cbuf, ibufptr + 5) = mki$(ibitsum)           'write the bitsum
            ibufptr = ibufptr + 16   'incr. buffer-pointer to next key position
         case else
      end select
   loop
   close ifno                                       'close the description file
   mid$(cbuf, 5) = mki$(ikeynum + 1)             'write #keys to Btrieve buffer
   if ialtseq then                          'alt-collating program flag is TRUE
      mid$(cbuf, ibufptr + 1) = char(172)       'write ASCII 172 to Btrv buffer
      mid$(cbuf, ibufptr + 2) = "UPPER   "            'put alt-header to buffer
      ibufptr = ibufptr + 9                   'increment Btrieve buffer-pointer
      for ichr = 0 to 255                        'loop thru ASCII character set
         ibufptr = ibufptr + 1                'increment Btrieve buffer-pointer
         if ichr < 97 or ichr > 122 then            'character is not lowercase
            mid$(cbuf, ibufptr) = char(ichr)          'put char. to Btrv buffer
         else                                   'current character is lowercase
            mid$(cbuf, ibufptr) = char(ichr - 32)          'uppercase to buffer
         end if
      next
   end if
   if right$(cdst, 1) <> char(0) and right$(cdst, 1) <> char(32) then
      cdst = cdst + " "   'terminating character missing in filename; append it
   end if                                      'create the Btrieve file [below]
   io.btrvfcre = BTRV(BTRV.CREATE, cfcb, cbuf, ibufptr, cdst, 0)
end function
