'/* BTRVSAVE.BAS Copy source Btrieve file to dest. text file */
'/*              By: Dale Thorn                              */
'/*              Rev. 13.01.2003                             */

'/* ////////////////////////////////////////////////////////
'/* OK to compile with PDQ lib [custom 'dfn.round' function]
'/* \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

'$include: 'basdef.h'
'$include: 'btrieve.h'
'$include: 'filekill.h'
'$include: 'fileopen.h'
'$include: 'longname.h'
'$include: 'messages.h'
'$include: 'midchar.h'
'$include: 'parmstr1.h'
'$include: 'string.h'

declare function ierrproc(cerrmsg, cfilbuf, lerrptr, ierrset, ierrfil, _
                          ibuflen, istatus, imsgdisp, iexit)
declare function ifn.ldfs(cfldlst, cddfnam, cfldnam(), cfldtyp(), _
                          ifldbeg(), ifldlen(), ifldmax)
declare function io.kget(inop)
declare function io.ktst(inop)

'$include: 'basdef.bas'
'$include: 'btrieve.bas'
'$include: 'filekill.bas'
'$include: 'fileopen.bas'
'$include: 'longname.bas'
'$include: 'messages.bas'
'$include: 'midchar.bas'
'$include: 'parmstr1.bas'
'$include: 'string.bas'

dim cfilnam(9)                               'initialize Btrieve file filenames
dim cfilbuf(9)                            'initialize Btrieve file data buffers
dim ckeybuf(9)                             'initialize Btrieve file key buffers
dim cposblk(9)                         'initialize Btrieve file position blocks
dim ibuflen(9)                          'initialize Btrieve file buffer lengths
dim ikeylen(9)                             'initialize Btrieve file key lengths
dim ikeynum(9)                                  'initialize Btrieve key numbers
dim istatus(9)                                 'initialize Btrieve status codes

dim cfldnam(255)                      'field names for importing/exporting data
dim cfldtyp(255)                      'field types for importing/exporting data
dim ifldbeg(255)                    'field offsets for importing/exporting data
dim ifldlen(255)                    'field lengths for importing/exporting data

ccmd = ucase$(rtrim$(command$))         'get the user's command-line parameters
if ccmd = "" then                              'a command line was NOT supplied
   cls                                                'clear the display screen
   print
   cmsg = "Usage:  BTRVSAVE  source  dest                                  "
   ctmp = space$(4)                        'initialize the messages left margin
   ipos1 = 33                                    'position for add'l parameters
   mid$(cmsg, ipos1) = "/EC (export CSV)                "
   print ctmp; cmsg
   mid$(cmsg, 1) = "      "
   mid$(cmsg, ipos1) = "/ES (export SQL7)               "
   print ctmp; cmsg
   mid$(cmsg, ipos1) = "/EU (export BUTIL)              "
   print ctmp; cmsg
   mid$(cmsg, ipos1) = "/K# (key number [/KP=phys.seq.])"
   print ctmp; cmsg
   mid$(cmsg, ipos1) = "/Sx (substitute 'x' for commas) "
   print ctmp; cmsg
   mid$(cmsg, ipos1) = "/T (field titles)               "
   print ctmp; cmsg
   mid$(cmsg, ipos1) = "/N (no displays)                "
   print ctmp; cmsg
   print
   print ctmp; "'/EC', '/ES', or '/EU' export specification is required."
   print
   print ctmp; "If '/EC' specified, the first line of the field script"
   print ctmp; "must contain the full path plus the Btrieve filename."
   print
   print ctmp; "If '/ES' specified, the first line of the field script"
   print ctmp; "must contain the DDF table name.  The actual Btrieve"
   print ctmp; "filename is the field script name less the extension."
   print
   print ctmp; "If '/Kx' specified, use Btrieve key number or phys. seq."
   print ctmp; "If '/Sx' specified, substitute 'x' for any commas found."
   print ctmp; "If '/T' specified export titles for the exported fields."
   print ctmp; "If '/N' specified do not display messages unless errors."
   print
   print ctmp; "'source' is the source field script filename."
   print ctmp; "'dest' is the dest.text data output filename.";
   close                              'close all files in case not closed above
   system                                   'return control to operating system
end if                              'display the usage message [above] and exit

ikeyseq = 0                           'source file key number to normal default
iphyseq = 0                         'flag to read source file in physical order
ipos1 = instr(ccmd, "/K")              'user selected to change the key access?
if ipos1 then                          'user selected to change the key access!
   ctmp = mid$(ccmd, ipos1 + 2, 1)     'extract key number or physical sequence
   if ctmp = "P" then                  'user selected to read physical sequence
      iphyseq = not 0                   'set the read physical sequence flag ON
   else                                   'user selected to read a key sequence
      ikeyseq = pdqvali(ctmp)                 'set the key# to user's selection
   end if
   ccmd = left$(ccmd, ipos1 - 1) + mid$(ccmd, ipos1 + 3)   'remove '/K#' switch
end if

crep = ""                              'initialize comma substitution character
ipos1 = instr(ccmd, "/S")             'user selected to replace commas with 'x'
if ipos1 then                         'user selected to replace commas with 'x'
   crep = rtrim$(mid$(ccmd, ipos1 + 2, 1))  'extract the substitute/replacement
   if crep <> "" then                  'substitute/replacement character valid!
      ccmd = left$(ccmd, ipos1 - 1) + mid$(ccmd, ipos1 + 3)'remove '/Sx' switch
   else                                   'no substitute - eliminate all commas
      ccmd = left$(ccmd, ipos1 - 1) + mid$(ccmd, ipos1 + 2)'remove '/Sx' switch
   end if
end if

iexpbut = 0                            'flag for exporting data in BUTIL format
iexpcsv = 0                              'flag for exporting data in CSV format
iexpsql = 0                             'flag for exporting data in SQL7 format
ipos1 = instr(ccmd, "/EC")                    'user selected to use CSV format?
ipos2 = instr(ccmd, "/ES")                   'user selected to use SQL7 format?
ipos3 = instr(ccmd, "/EU")                  'user selected to use BUTIL format?
if ipos1 then                                 'user selected to use CSV format!
   iexpcsv = not 0                       'set flag to export data in CSV format
   ccmd = rtrim$(left$(ccmd, ipos1 - 1) + mid$(ccmd, ipos1 + 3)) 'remove switch
elseif ipos2 then                            'user selected to use SQL7 format!
   iexpsql = not 0                      'set flag to export data in SQL7 format
   ccmd = rtrim$(left$(ccmd, ipos2 - 1) + mid$(ccmd, ipos2 + 3)) 'remove switch
elseif ipos3 then                           'user selected to use BUTIL format!
   iexpbut = not 0                     'set flag to export data in BUTIL format
   ccmd = rtrim$(left$(ccmd, ipos3 - 1) + mid$(ccmd, ipos3 + 3)) 'remove switch
else                                     'user failed to specify a valid option
   i = ifn.msgs("Invalid operation parameter", 5, 24, 79, 1, 1)
end if                                  'display error message [above] and exit

ipos1 = instr(ccmd, "/N")               'don't display (except error) messages?
if ipos1 then                                 'user said don't display messages
   imsgdisp = 0                                'set message display flag to OFF
   ccmd = rtrim$(left$(ccmd, ipos1 - 1) + mid$(ccmd, ipos1 + 2))   'remove '/N'
else                                          'user said OK to display messages
   imsgdisp = not 0                             'set message display flag to ON
end if
ipos1 = instr(ccmd, "/T")                    'user said to export field titles?
if ipos1 then                                'user said to export field titles!
   ititles = not 0                           'set export all field titles to ON
   ccmd = rtrim$(left$(ccmd, ipos1 - 1) + mid$(ccmd, ipos1 + 2))   'remove '/T'
else                                       'user said don't export field titles
   ititles = 0                              'set export all field titles to OFF
end if

iprm = parmstr1(" " + ccmd, "", "", "", cprm())  'parse command-line parameters
if iprm <> 1 then                                 'invalid number of parameters
   i = ifn.msgs("Invalid number of parameters", 5, 24, 79, 1, 1)
end if                                  'display error message [above] and exit

if iexpcsv or iexpsql then             'output all records to text or SQL7 file
   i = ifn.ldfs(cprm(0), cddfnam, cfldnam(), cfldtyp(), _
                ifldbeg(), ifldlen(), ifldmax)   'load user-specified fieldlist
end if

if iexpbut then                        'output all records to BUTIL format file
   cfilnam(0) = cprm(0)                 'set Btrieve filename from source entry
elseif iexpcsv then                      'output all records to CSV format file
   cfilnam(0) = cddfnam                  'set Btrieve filename from script line
elseif iexpsql then                     'output all records to SQL7 format file
   ilen1 = len(cprm(0))                   'get length of source script filename
   ipos1 = istr.rcfn(ilen1, cprm(0), ".")       'script file extension position
   if ipos1 = 0 then                              'filename extension NOT found
      ipos1 = ilen1 + 1                           'set position to end plus one
   elseif ipos1 < ilen1 - 3 then                    'invalid extension position
      i = ifn.msgs("Invalid filename extension position", 5, 24, 79, 1, 1)
   end if                               'display error message [above] and exit
   cfilnam(0) = left$(cprm(0), ipos1 - 1)'set Btrieve filename from script file
else                                                  'invalid option specified
   i = ifn.msgs("Invalid option specified", 5, 24, 79, 1, 1)
end if                                  'display error message [above] and exit
ilen1 = len(cfilnam(0))                         'get length of Btrieve filename
ipos1 = istr.rcfn(ilen1, cfilnam(0), ".")      'Btrieve file extension position
if ipos1 = 0 then                                 'extension position NOT found
   ipos1 = ilen1 + 1                              'set position to end plus one
end if
ctxtnam = left$(cfilnam(0), ipos1 - 1)   'text filename less filename extension
crtnlnf = char(13) + char(10)         'initialize the carriage-return/line-feed
ctxtlen = space$(5)                  'initialize the BUTIL record length buffer

ibuflen(0) = 4096           'initialize Btrieve buffer length to system maximum
ikeylen(0) = 128               'initialize Btrieve key length to system maximum
ikeynum(0) = ikeyseq          'set Btrieve key number from user/default [above]
cfilbuf(0) = string$(ibuflen(0), 0)        'initialize Btrieve file data buffer
ckeybuf(0) = string$(ikeylen(0), 0)         'initialize Btrieve file key buffer
cposblk(0) = string$(128, 0)            'initialize Btrieve file position block

istatus(0) = BTRV(BTRV.OPEN, cposblk(0), cfilbuf(0), _
                  (ibuflen(0)), cfilnam(0) + " ", BTRV.NORMAL)'open Btrieve file
if istatus(0) then                              'error opening the Btrieve file
   i = ierrproc(" opening " + cfilnam(0), "", 0, 0, 0, 0, istatus(0), imsgdisp, 1)
end if                                  'display error message [above] and exit
istatus(0) = BTRV(BTRV.STAT, cposblk(0), cfilbuf(0), _
                  (ibuflen(0)), ckeybuf(0), 0)     'get the Btrieve file status
if istatus(0) then                           'error getting Btrieve file status
   i = ierrproc(" getting STAT from " + cfilnam(0), "", _
                0, 0, 0, 0, istatus(0), imsgdisp, 1)
end if                                  'display error message [above] and exit
if cvi(mid$(cfilbuf(0), 11, 2)) mod 2 then     'Btrieve file is variable-length
   ibuflen(0) = cvi(mid$(cfilbuf(0), 3, 2))     'set record length to page size
   ivarlen = not 0                              'set variable-length flag to ON
else                                          'Btrieve file NOT variable-length
   ibuflen(0) = cvi(mid$(cfilbuf(0), 1, 2))     'set record length=fixed length
   cfilbuf(0) = ""                            'reinitialize Btrieve file buffer
   cfilbuf(0) = string$(ibuflen(0), 0)        'set buffer length to STAT length
   ivarlen = 0                                 'set variable-length flag to OFF
end if

lerrptr = 1                           'initialize the error-output file pointer
ierrset = 0                            'initialize the error-output file status
ilogfil = freefile                        'initialize the error-log file number
open ctxtnam + ".log" for output as ilogfil 'open log file in output write mode
ltxtptr = 1                                'initialize text-output file pointer
itxtfil = freefile                          'initialize text-output file number
open cprm(1) for output as itxtfil             'open the dest. export text file

if imsgdisp then                              'user said OK to display messages
   i = ifn.msgs("Copying " + cfilnam(0), 5, 24, 79, 0, 0)    'OK to proceed....
end if

if iexpcsv and ititles then              'output all records to CSV format file
   for ifldndx = 0 to ifldmax - 1             'loop thru the text output fields
      print #itxtfil, cfldnam(ifldndx); ",";       'print the current fieldname
   next
   print #itxtfil, cfldnam(ifldndx)                  'print the final fieldname
end if

if iphyseq then                     'read the Btrieve file in physical sequence
   ibtrvop = BTRV.STEPFIRST          'get the first record in physical sequence
else                                 'read the Btrieve file in key no. sequence
   ibtrvop = BTRV.GETLO               'get the first record in key no. sequence
end if
itmpbuflen = ibuflen(0)               'make copy so Btrieve can't change buflen
istatus(0) = BTRV(ibtrvop, cposblk(0), cfilbuf(0), _
                  itmpbuflen, ckeybuf(0), ikeynum(0)) 'get first Btrieve record
lrecordatt = 0                       'initialize the 'nnn records read' counter
lrecordcnt = 0                     'initialize the 'nnn records copied' counter
while istatus(0) = 0 or istatus(0) = 22         'loop until end of Btrieve file
   lrecordatt = lrecordatt + 1            'increment 'nnn records read' counter
   ctmpfilbuf = left$(cfilbuf(0), itmpbuflen) 'make temp.copy of Btrieve buffer
   if ivarlen then                             'Btrieve file is variable-length
      itmpbuflen = len(rtrim$(ctmpfilbuf))   'set Btrieve buflen=trimmed length
      if itmpbuflen < ibuflen(0) then         'trimmed length is < fixed length
         itmpbuflen = ibuflen(0)            'set Btrieve buflen to fixed length
      end if
   else                                    'Btrieve file is NOT variable-length
      itmpbuflen = ibuflen(0)               'set so Btrieve can't change buflen
   end if
   if iexpbut then                            'output user data in BUTIL format
      ctxtlen = ltrim$(str$(itmpbuflen))          'output Btrieve buffer length
      ctxtbuf = ctxtlen + "," + ctmpfilbuf + crtnlnf      'create output record
      print #itxtfil, ctxtbuf;                   'write record to the text file
      ltxtptr = ltxtptr + len(ctxtbuf)         'increment the text file pointer
   else                                        'output user data in text format
      if iexpsql then                        'output all records in SQL7 format
         print #itxtfil, "insert "; cddfnam; "(";        'output the fieldnames
         for ifldndx = 0 to ifldmax           'loop thru the SQL7 output fields
            print #itxtfil, cfldnam(ifldndx);      'print the current fieldname
            if ifldndx < ifldmax then               'current fieldname NOT last
               print #itxtfil, ",";                 'output fieldname separator
            end if
         next
         print #itxtfil, ") values(";          'terminate the fieldnames output
      end if
      for ifldndx = 0 to ifldmax              'loop thru the text output fields
         if ifldbeg(ifldndx) > 0 then              'field exists in source file
            cfldval = mid$(cfilbuf(0), ifldbeg(ifldndx), ifldlen(ifldndx))
         else                              'field does NOT exist in source file
            cfldval = string$(ifldlen(ifldndx), 0)           'source field data
         end if
         i = istr.fmtx(cfldval, cfldtyp(ifldndx), 0, iexpsql)
         ipos1 = 1                                'begin field parse at byte #1
         ilen1 = len(cfldval)                    'stripped length of field data
         while ipos1 <= ilen1                        'loop thru the data string
            ichr = midchar(cfldval, ipos1)           'character at current posn.
            if ichr = 39 then                     'current character is a quote
               cfldval = left$(cfldval, ipos1 - 1) + mid$(cfldval, ipos1 + 1)
               ilen1 = ilen1 - 1                'remove char/adjust data length
               print #ilogfil, "Quote removed from field '"; _
                               cfldnam(ifldndx); "'"; tab(49); _
                               "in table '"; cddfnam; "'"
            elseif ichr = 44 then                 'current character is a comma
               if crep <> "" then                 'user specified a subst. char.
                  mid$(cfldval, ipos1) = crep      'replace comma w/subst. char.
                  print #ilogfil, "Comma replaced in field '"; _
                                  cfldnam(ifldndx); "'"; tab(49); _
                                  "in table '"; cddfnam; "'"
               else                             'substitute char. NOT specified
                  if ipos1 = 1 or ipos1 = ilen1 then   '1st/last char. in field
                     ispace = 0                      'set set-space flag to OFF
                  else                               'middle character in field
                     if midchar(cfldval, ipos1 - 1) = 32 _  'prev.char.is space
                     or midchar(cfldval, ipos1 + 1) = 32 then 'next char.=space
                        ispace = 0                      'set set-space flag OFF
                     else                               'next char. NOT a space
                        ispace = not 0                   'set set-space flag ON
                     end if
                  end if
                  if ispace then                'OK to replace comma with space
                     mid$(cfldval, ipos1) = " "       'replace comma with space
                  else                          'don't replace comma with space
                     cfldval = left$(cfldval, ipos1 - 1) + mid$(cfldval, ipos1 + 1)
                     ilen1 = ilen1 - 1          'remove char/adjust data length
                  end if                        'remove comma from line [above]
                  print #ilogfil, "Comma removed from field '"; _
                                  cfldnam(ifldndx); "'"; tab(49); _
                                  "in table '"; cddfnam; "'"
               end if
            elseif ichr < 32 then                 'invalid (non-text) character
               mid$(cfldval, ipos1) = "."           'replace character with dot
               ipos1 = ipos1 + 1                  'move parse posn.to next byte
            else                                 'no invalid chars.at this posn.
               ipos1 = ipos1 + 1                  'move parse posn.to next byte
            end if
         wend
         if iexpsql then                     'output all records in SQL7 format
            print #itxtfil, "'"; cfldval; "'";       'output current field data
         else                                'output all records in text format
            print #itxtfil, cfldval;                 'output current field data
         end if
         if ifldndx < ifldmax then            'current field NOT at end of line
            print #itxtfil, ",";                'print separator for next field
         end if
      next
      if iexpsql then                        'output all records in SQL7 format
         print #itxtfil, ")"                    'terminate the SQL7 output line
      else                                   'output all records in text format
         print #itxtfil, ""                     'terminate the text output line
      end if
   end if
   if iphyseq then                   'read the source file in physical sequence
      ibtrvop = BTRV.STEPNEXT         'get the next record in physical sequence
   else                               'read the source file in key no. sequence
      ibtrvop = BTRV.GETNEXT           'get the next record in key no. sequence
   end if
   itmpbuflen = ibuflen(0)            'make copy so Btrieve can't change buflen
   istatus(0) = BTRV(ibtrvop, cposblk(0), cfilbuf(0), _
                     itmpbuflen, ckeybuf(0), ikeynum(0))
   if io.ktst(0) = 27 then                            'user pressed the ESC key
      i = BTRV(BTRV.RESET, "", "", 0, "", 0)           'close all Btrieve files
      i = ifn.msgs("ESC selected - program aborted", 5, 24, 79, 0, 1)
   else                     'record added OK and user did NOT press the ESC key
      lrecordcnt = lrecordcnt + 1       'increment 'nnn records copied' counter
   end if
   if (lrecordatt mod 100 = 0) and imsgdisp then '#records is a multiple of 100
      locate 7, 5, 1              'locate cursor for 'nnn records read' counter
      print right$("      " + str$(lrecordatt), 7); " records read"
      locate 9, 5, 1            'locate cursor for 'nnn records copied' counter
      print right$("      " + str$(lrecordcnt), 7); " records copied"
      locate 24, 79, 0                                'hide' the display cursor
   end if
wend                                  'get next record from source file [above]
if istatus(0) <> BTRV.EOF then           'unexpected error getting first record
   i = ierrproc(" getting record from " + cfilnam(0), "", 0, ierrset, 0, 0, _
                istatus(0), imsgdisp, 1)        'display error message and exit
end if

if iexpbut then                             'output all records in BUTIL format
   close itxtfil                              'close the dest. text-output file
   open cprm(1) for binary as itxtfil          'reopen text file in binary mode
   put itxtfil, ltxtptr, char(26)              'write EOF byte to the text file
end if
if imsgdisp then                              'user said OK to display messages
   i = ifn.msgs("Copy completed", 5, 24, 79, 0, 0) 'display 'completed' message
   locate 7, 5, 1                 'locate cursor for 'nnn records read' counter
   print right$("      " + str$(lrecordatt), 7); " records read"
   locate 9, 5, 1               'locate cursor for 'nnn records copied' counter
   print right$("      " + str$(lrecordcnt), 7); " records copied"
   locate 11, 5, 1                          'locate cursor for text out message
   print "Output records are located in the '"; cprm(1); "' file"
   if ierrset then                            'error-output file status was set
      locate 13, 5, 1                          'locate cursor for error message
      print "Error records are located in the '"; ctxtnam; ".err' file"
   end if
end if
i = BTRV(BTRV.RESET, "", "", 0, "", 0)            'close all open Btrieve files
close                                              'close all non-Btrieve files
system                                              'return to operating system

function ierrproc(cerrmsg, cfilbuf, lerrptr, ierrset, ierrfil, _
                  ibuflen, istatus, imsgdisp, iexit)
   if lerrptr then                           'OK to write record to output file
      cerrlen = ltrim$(str$(ibuflen))          'length of output Btrieve buffer
      cerrbuf = cerrlen + "," + left$(cfilbuf, ibuflen) + char(13) + char(10)
      put ierrfil, lerrptr, cerrbuf                'write record to output file
      lerrptr = lerrptr + len(cerrbuf)            'increment error file pointer
   end if
   if (not ierrset) and imsgdisp then 'error message has NOT yet been displayed
      i = ifn.msgs("Error " + ltrim$(str$(istatus)) + cerrmsg, 5, 24, 79, 1, 0)
      if lerrptr then                  'error record was written to output file
         ierrset = not 0               'error record written; set error flag ON
      end if
   end if
   if iexit then                              'OK to return to operating system
      if ierrset then                         'error-output file status was set
         locate 7, 5, 1                        'locate cursor for error message
         print "Error records are located in the matching '.err' file"
      else                                    'error-output file status NOT set
         locate 6, 1, 1                       'locate cursor for exit to system
      end if
      if istatus <> BTRV.ERR then           'status != Btrieve-not-loaded error
         i = BTRV(BTRV.RESET, "", "", 0, "", 0)   'close all open Btrieve files
      end if
      close                                        'close all non-Btrieve files
      system                                        'return to operating system
   end if
end function

function ifn.ldfs(cfldlst, cddfnam, cfldnam(), cfldtyp(), _
                  ifldbeg(), ifldlen(), ifldmax) 'load user-specified fieldlist
   ifilnum = freefile                           'get next available file handle
   i = ifn.open(ifilnum, cfldlst, "s", llof)     'open the field list spec file
   if llof = 0 then                            'field list nonexistent or empty
      i = ifn.kill(ifilnum, cfldlst)           'kill the zero-length field file
      i = ifn.msgs("'" + cfldlst + "' file not found", 5, 24, 79, 1, 1)
   end if                               'display error message [above] and exit
   if eof(ifilnum) then                  'we're at EOF (no fieldspecs possible)
      i = ifn.msgs("No fieldspecs in '" + cfldlst + "' file", 5, 24, 79, 1, 1)
   end if                               'display error message [above] and exit
   line input #ifilnum, cddfnam               'get the DDF table (or file) name
   ipos1 = instr(cddfnam, ",")                 'position of comma in table name
   if ipos1 then                                 'comma was found in table name
      cddfnam = rtrim$(left$(cddfnam, ipos1 - 1))  'extract cddfnam from string
   end if
   ifldmax = -1                                 'initialize the fieldspec index
   while not eof(ifilnum)                         'loop until end of fieldspecs
      line input #ifilnum, clin                    'get the next fieldspec line
      clin = ltrim$(rtrim$(clin))                 'trim the next fieldspec line
      if clin <> "" then                        'current fieldspec is NOT blank
         ifldmax = ifldmax + 1                   'increment the fieldspec index
         ipos1 = instr(clin, ",")            '1st separator posn. in field line
         ipos2 = instr(ipos1 + 1, clin, ",") '2nd separator posn. in field line
         ipos3 = instr(ipos2 + 1, clin, ",") '3rd separator posn. in field line
         if ipos2 = 0 or ipos3 = 0 then          'separator positions NOT found
            i = ifn.msgs("Invalid fieldspec in '" + cfldlst + "' file", _
                         5, 24, 79, 1, 1)       'display error message and exit
         end if
         cfldnam(ifldmax) = ltrim$(rtrim$(mid$(clin, 1, ipos1 - 1)))
         cfldtyp(ifldmax) = ltrim$(rtrim$(mid$(clin, ipos1 + 1, ipos2 - ipos1 - 1)))
         ifldbeg(ifldmax) = pdqvali(mid$(clin, ipos2 + 1))    'field offset + 1
         ifldlen(ifldmax) = pdqvali(mid$(clin, ipos3 + 1))  'total field length
      end if
   wend
   close ifilnum                                'close the field list spec file
end function

function io.kget(inop)                       'strip key buffer and wait for key
   while inkey$ <> ""                           'begin loop to strip key buffer
   wend                                   'loop while key buffer contains a key
   do                                                               'begin loop
      ckey = inkey$                                    'get key from key buffer
   loop while ckey = ""                                'loop until a key is hit
   if asc(ckey) then                                   'key value in first byte
      io.kget = asc(ckey)                  'return key value to calling program
   else                                            'zero value ("extended" key)
      io.kget = asc(mid$(ckey, 2)) + 128       'return 2nd byte of key plus 128
   end if
end function

function io.ktst(inop)                               'return last key (no wait)
   ckey = inkey$                                       'get key from key buffer
   if ckey <> "" then                                'key buffer contains a key
      if asc(ckey) then                                'key value in first byte
         io.ktst = asc(ckey)                               'key value to return
      else                                         'zero value ("extended" key)
         io.ktst = asc(mid$(ckey, 2)) + 128    'return 2nd byte of key plus 128
      end if
   else                                      'key buffer does NOT contain a key
      io.ktst = 0                                 'set return key value to zero
   end if
end function
