'/* BTRVUPDT.BAS Insert, delete, or modify Btrieve data records */
'/*              By: Dale Thorn                                 */
'/*              Rev. 05.08.2002                                */

'$include: 'basdef.h'
'$include: 'btrieve.h'
'$include: 'longname.h'
'$include: 'messages.h'
'$include: 'midchar.h'
'$include: 'parmstr1.h'
'$include: 'string.h'

declare function iupd.pars(cstr, copt, lbeg, lcnt)
declare function iupd.repl(cstr)
declare function io.kget(inop)
declare function io.ktst(inop)

'$include: 'basdef.bas'
'$include: 'btrieve.bas'
'$include: 'longname.bas'
'$include: 'messages.bas'
'$include: 'midchar.bas'
'$include: 'parmstr1.bas'
'$include: 'string.bas'

dim cfldtyp(4)                                'field data types (A, I, L, etc.)
dim ifldlen(4)                                  'field- and key-segment lengths

ccmd = rtrim$(command$)                 'get the user's command-line parameters
if ccmd = "" then                              'a command line was NOT supplied
   cls                                                'clear the display screen
   cmsg = "   Usage:  BTRVUPDT  filename  fldbeg" + _
          "  type  'data'  keytype  'data'         "   'initialize message line
   i = iupd.repl(cmsg)                'replace single quotes with double quotes
   ipos = instr(cmsg, "keytype")               'position of 'keytype' parameter
   mid$(cmsg, ipos + 17) = "[/K#]  "            'add key# spec to usage message
   print cmsg                                    'display current usage message
   mid$(cmsg, 4) = "      "                    'blank 'usage:' in usage message
   mid$(cmsg, ipos + 17) = "[/D#,#]"            'add dupl.spec to usage message
   print cmsg                                    'display current usage message
   mid$(cmsg, ipos + 17) = "[/R#,#]"            'add rcd#.spec to usage message
   print cmsg                                    'display current usage message
   mid$(cmsg, ipos + 17) = "[/N#,#]"           'add auto#.spec to usage message
   print cmsg                                    'display current usage message
   mid$(cmsg, ipos + 17) = "[/OR]  "         'add reverse spec to usage message
   print cmsg                                    'display current usage message
   mid$(cmsg, ipos + 17) = "[/I]   "          'add insert spec to usage message
   print cmsg                                    'display current usage message
   mid$(cmsg, ipos + 17) = "[/X]   "          'add delete spec to usage message
   print cmsg                                    'display current usage message
   print                                           'blank line between messages
   print "   Notes:  If '/K#'   specified, use Btrieve key '#' [0 - 99]"
   print "           If '/D#,#' specified, '#,#' = dupl.begin,dupl.count"
   print "           If '/R#,#' specified, '#,#' = rcd#.begin,rcd#.count"
   print "           If '/N#,#' specified, '#,#' = auto#begin,increment"
   print "           If '/OR'   specified, process in reverse sequence"
   print "           If '/I'    specified, copy/insert selected records"
   print "           If '/X'    specified, delete all selected records"
   print "           If '~' specified for record count, process to end of file"
   print "           If '~' specified for auto begin, use current field values"
   print "           If '~' specified for autoinc, reset auto begin on key chg"
   print                                           'blank line between messages
   print "   Data    Snn = Text string ('nn' = length)"
   print "   Types:   D  = Btrv. date (mm-dd-yy  -or-  dd.mm.yy)"
   print "            T  = Btrv. time (hh:mm:ss) :  A = Byte (0 to 255)"
   print "            I  = Short integer (16bit) :  L = Long integer (32bit)"
   print "           M4  = MBF single-precision  : I4 = IEEE single-precision"
   print "           M8  = MBF double-precision  : I8 = IEEE double-precision";
   i = io.kget(0)                       'wait for user-pressed key to terminate
   close                              'close all files in case not closed above
   system                                   'return control to operating system
end if

idelete = 0                        'initialize the delete-selected-records flag
iinsert = 0                        'initialize the insert-selected-records flag
ikeynum = 0                        'initialize the key number to zero (default)
ikeyrev = 0                        'initialize the process-keys-in-reverse flag
ldupbeg = 0                     'initialize the duplicate number begin sequence
ldupcnt = 0                        'initialize the duplicate number count value
lnumbeg = 0                       'initialize the auto-numbering begin sequence
lnumcnt = 0                          'initialize the auto-numbering count value
lrcdbeg = 0                        'initialize the record number begin sequence
lrcdcnt = 0                           'initialize the record number count value
lsavbeg = 0                        'initialize the save auto-number begin value
lsavcnt = 0                        'initialize the save auto-number incr. value
do                                 'begin loop to process command-line switches
   if ucase$(right$(ccmd, 3)) = "/OR" then     'user said to process in reverse
      ikeyrev = not 0                              'set process-in-reverse flag
      ccmd = rtrim$(left$(ccmd, len(ccmd) - 3))   'remove '/OR' from parameters
   elseif ucase$(right$(ccmd, 2)) = "/I" then 'user specified to insert records
      iinsert = not 0                         'set insert-selected-records flag
      ccmd = rtrim$(left$(ccmd, len(ccmd) - 2))    'remove '/I' from parameters
   elseif ucase$(right$(ccmd, 2)) = "/X" then 'user specified to delete records
      idelete = not 0                         'set delete-selected-records flag
      ccmd = rtrim$(left$(ccmd, len(ccmd) - 2))    'remove '/X' from parameters
   elseif ucase$(left$(right$(ccmd, 3), 2)) = "/K" then'user-specified key# 0-9
      ikeynum = pdqvali(right$(ccmd, 1))            'set user-specified key no.
      ccmd = rtrim$(left$(ccmd, len(ccmd) - 3))   'remove '/K#' from parameters
   elseif ucase$(left$(right$(ccmd, 4), 2)) = "/K" then   'key# 10-up specified
      ikeynum = pdqvali(right$(ccmd, 2))            'set user-specified key no.
      ccmd = rtrim$(left$(ccmd, len(ccmd) - 4))   'remove '/K#' from parameters
   elseif ldupbeg = 0 and istr.rsfn(len(ccmd), ucase$(ccmd), "/D") > 0 then
      i = iupd.pars(ccmd, "/D", ldupbeg, ldupcnt) 'parse the dupl.specification
   elseif lrcdbeg = 0 and istr.rsfn(len(ccmd), ucase$(ccmd), "/R") > 0 then
      i = iupd.pars(ccmd, "/R", lrcdbeg, lrcdcnt) 'parse record # specification
   elseif lsavbeg = 0 and istr.rsfn(len(ccmd), ucase$(ccmd), "/N") > 0 then
      i = iupd.pars(ccmd, "/N", lsavbeg, lsavcnt) 'parse the auto-num specifier
      lnumbeg = lsavbeg                 'initialize the auto-number begin value
      lnumcnt = lsavcnt                 'initialize the auto-number incr. value
   else                                 'all of command-line switches processed
      exit do                          'end of command-line switches; exit loop
   end if
loop

iprm = parmstr1(ccmd, cfil, cnam, cext, cprm())  'parse command-line parameters
if cnam = "" or len(cnam) > 8 or len(cext) > 3 or instr(cext, ".") then
   i = ifn.msgs("Invalid filename", 5, 24, 79, 1, 1)
end if                                  'display error message [above] and exit
if iprm < 4 or iprm > 8 or iprm mod 2 then          'wrong number of parameters
   i = ifn.msgs("Invalid number of parameters", 5, 24, 79, 1, 1)
end if                                  'display error message [above] and exit

ifldbeg = pdqvali(cprm(0))                           'get the field begin value
if ifldbeg <= 0 then                            'user input invalid field begin
   i = ifn.msgs("Invalid field begin", 5, 24, 79, 1, 1)
end if                                  'display error message [above] and exit

for i0 = 2 to iprm step 2                   'loop thru the data type parameters
   indx = i0 \ 2                              'initialize temporary array index
   cfldtyp(indx) = ucase$(cprm(i0 - 1))        'initialize the field data types
   select case cfldtyp(indx)                     'select on the field data type
      case "A"                                         'A' = ASCII character
         ifldlen(indx) = 1                             'set data segment length
      case "I"                                         'I' = Short integer
         ifldlen(indx) = 2                             'set data segment length
      case "I4", _                                     'I4' = Single IEEE float
           "M4", _                                     'M4' = Single MBF float
           "D", _                                      'D'  = Btrieve date
           "L", _                                      'L'  = Long integer
           "T"                                         'T'  = Btrieve time
         ifldlen(indx) = 4                             'set data segment length
      case "M8", _                                     'M8' = Double MBF float
           "I8"                                        'I8' = Double IEEE float
         ifldlen(indx) = 8                             'set data segment length
      case else                                        'Snn' = String
         if left$(cfldtyp(indx), 1) = "S" then         'string S-type specified
            ifldlen(indx) = pdqvali(mid$(cfldtyp(indx), 2)) 'set segment length
            if ifldlen(indx) <= 0 then                  'invalid segment length
               i = ifn.msgs("Invalid field length", 5, 24, 79, 1, 1)
            end if                      'display error message [above] and exit
         else                              'user specified an invalid data type
            i = ifn.msgs("Invalid data type - check usage list", 5, 24, 79, 1, 1)
         end if                         'display error message [above] and exit
   end select                           'validate the field or key data [below]
   if left$(cprm(i0), 1) <> char(34) or right$(cprm(i0), 1) <> char(34) _
   or len(cprm(i0)) < 2 then              'user input invalid field or key data
      i = ifn.msgs("Invalid field or key data - must be enclosed in quotes", _
                   5, 24, 79, 1, 1)
   end if                               'display error message [above] and exit
   cprm(i0) = mid$(cprm(i0), 2, len(cprm(i0)) - 2)'remove quotes from field data
next

if ldupbeg > 0 or lrcdbeg > 0 then      'user specified multi-record processing
   crcdmsg1 = "Records"                'set 'Records not found' message segment
   crcdmsg2 = "records"                  'set 'records updated' message segment
else                                       'user said to update just one record
   crcdmsg1 = "Record"                  'set 'Record not found' message segment
   crcdmsg2 = "record"                    'set 'record updated' message segment
end if

if iinsert then                               'user specified to insert records
   coptmsg1 = "INSERT"                        'set the 'INSERT' message segment
   coptmsg2 = "inserted"                    'set the 'inserted' message segment
   ibtrvop  = BTRV.INSERT                     'set the Btrieve INSERT oper.code
elseif idelete then                           'user specified to delete records
   coptmsg1 = "DELETE"                        'set the 'DELETE' message segment
   coptmsg2 = "deleted"                      'set the 'deleted' message segment
   ibtrvop  = BTRV.DELETE                     'set the Btrieve DELETE oper.code
else                                          'user specified to update records
   coptmsg1 = "UPDATE"                        'set the 'UPDATE' message segment
   coptmsg2 = "updated"                      'set the 'updated' message segment
   ibtrvop  = BTRV.UPDATE                     'set the Btrieve UPDATE oper.code
end if

isrcbuflen = 4096            'initialize source buffer length to system maximum
isrckeylen = 128                'initialize source key length to system maximum
isrckeynum = ikeynum           'set source key number from user/default [above]
csrcfilbuf = string$(isrcbuflen, 0)         'initialize source file data buffer
csrckeybuf = string$(isrckeylen, 0)          'initialize source file key buffer
csrcposblk = string$(128, 0)             'initialize source file position block
csrcrcdpos = string$(4, 0)               'initialize curr.saved record position
cnxtrcdpos = string$(4, 0)               'initialize next saved record position

isrcstatus = BTRV(BTRV.OPEN, csrcposblk, csrcfilbuf, _    'open the source file
                  (isrcbuflen), cfil + " ", BTRV.NORMAL)
if isrcstatus then                               'error opening the source file
   i = ifn.msgs("Error number " + ltrim$(str$(isrcstatus)) + _
                " opening " + cfil, 5, 24, 79, 1, 1)
end if                                  'display error message [above] and exit

isrcstatus = BTRV(BTRV.STAT, csrcposblk, csrcfilbuf, _
                  (isrcbuflen), csrckeybuf, 0)      'get the source file status
if isrcstatus then                            'error getting source file status
   i = ifn.msgs("Error getting STAT from " + cfil, 5, 24, 79, 1, 1)
end if                                  'display error message [above] and exit
if cvi(mid$(csrcfilbuf, 11, 2)) mod 2 then      'source file is variable-length
   isrcbuflen = cvi(mid$(csrcfilbuf, 3, 2))     'set record length to page size
else                                           'source file NOT variable-length
   isrcbuflen = cvi(mid$(csrcfilbuf, 1, 2))  'set record length to fixed length
   csrcfilbuf = ""                             'reinitialize source file buffer
   csrcfilbuf = string$(isrcbuflen, 0)        'set buffer length to STAT length
end if

i = ifn.msgs("Updating " + cfil, 5, 24, 79, 0, 0)             'OK to proceed...

ikeypos = 1                                'initialize the current key position
ikeyndx = 1                                'initialize the current key position
ikeylen = 0                                  'initialize the current key length
for i0 = 4 to iprm step 2                    'loop thru the key data parameters
   indx = i0 \ 2                              'initialize temporary array index
   csegval = cprm(i0)                       'make temp.copy of key segment data
   i = istr.fmti(csegval, cfldtyp(indx), ifldlen(indx))    'set internal format
   mid$(csrckeybuf, ikeyndx) = csegval      'put reformatted data to key buffer
   if i0 < iprm or cprm(i0) <> "" then     'not last seg.or user input key data
      if left$(cfldtyp(indx), 1) = "S" then    'string S-type segment specified
         ikeypos = ikeyndx + len(cprm(i0))   'incr. key position by text length
      else                                   'non-string-type segment specified
         ikeypos = ikeyndx + ifldlen(indx)    'incr. key position by seg.length
      end if
      ikeyndx = ikeyndx + ifldlen(indx)       'incr. key position by seg.length
   end if
   ikeylen = ikeylen + ifldlen(indx)    'increment key length by segment length
next

ctmpkeybuf = left$(csrckeybuf, ikeylen)      'make copy to compare match result
itmpbuflen = isrcbuflen               'make copy so Btrieve can't change buflen
if ikeyrev then                                'user said to process in reverse
   ifileop = BTRV.GETLE                       'get record <= to specified input
else                                             'user said to process normally
   ifileop = BTRV.GETGE                       'get record >= to specified input
end if
isrcstatus = BTRV(ifileop, csrcposblk, csrcfilbuf, itmpbuflen, _
                  csrckeybuf, isrckeynum)            'get first matching record
if isrcstatus or left$(csrckeybuf, ikeypos - 1) _
              <> left$(ctmpkeybuf, ikeypos - 1) then             'no key-match!
   i = BTRV(BTRV.RESET, "", "", 0, "", 0)               'close the Btrieve file
   i = ifn.msgs(crcdmsg1 + " not found in " + cfil, 5, 24, 79, 1, 1)
end if                                  'display error message [above] and exit
lset ctmpkeybuf = csrckeybuf        'reset key-match buffer to first actual key

lrcdatt = 0                          'initialize the 'nnn records read' counter
lrcdtot = 0                       'initialize the 'nnn records updated' counter
do                              'loop to process records per user specification
   isrcstatus = BTRV(BTRV.GETPOS, csrcposblk, csrcrcdpos, 4, _
                     csrckeybuf, isrckeynum)   'get position for current record
   if isrcstatus then                            'error getting record position
      i = BTRV(BTRV.RESET, "", "", 0, "", 0)            'close the Btrieve file
      i = ifn.msgs("Error getting current position in " + cfil, 5, 24, 79, 1, 1)
   end if                               'display error message [above] and exit
   itmpbuflen = isrcbuflen            'make copy so Btrieve can't change buflen
   if ikeyrev then                             'user said to process in reverse
      ifileop = BTRV.GETPREV                   'get the previous Btrieve record
   else                                          'user said to process normally
      ifileop = BTRV.GETNEXT                       'get the next Btrieve record
   end if
   inxtstatus = BTRV(ifileop, csrcposblk, csrcfilbuf, itmpbuflen, _
                     csrckeybuf, isrckeynum)      'get the next/previous record
   if inxtstatus = 0 then                        'next Btrieve record loaded OK
      isrcstatus = BTRV(BTRV.GETPOS, csrcposblk, cnxtrcdpos, 4, _
                        csrckeybuf, isrckeynum)   'get position for next record
      if isrcstatus then                         'error getting record position
         i = BTRV(BTRV.RESET, "", "", 0, "", 0)         'close the Btrieve file
         i = ifn.msgs("Error getting 'next' position in " + cfil, 5, 24, 79, 1, 1)
      end if                            'display error message [above] and exit
   end if
   lset csrcfilbuf = csrcrcdpos        'restore current Btrieve record position
   itmpbuflen = isrcbuflen            'make copy so Btrieve can't change buflen
   isrcstatus = BTRV(BTRV.GETDIRECT, csrcposblk, csrcfilbuf, itmpbuflen, _
                     csrckeybuf, isrckeynum)    'restore current Btrieve record
   if isrcstatus then                              'error getting record direct
      i = BTRV(BTRV.RESET, "", "", 0, "", 0)            'close the Btrieve file
      i = ifn.msgs("Error getting record direct in " + cfil, 5, 24, 79, 1, 1)
   end if                               'display error message [above] and exit
   select case cfldtyp(1)                        'select on the field data type
      case "D", _                                            'D' = Btrieve date
           "T"                                               'T' = Btrieve time
         cfldval = cprm(2)                        'make temp.copy of field data
      case else                                    'possible numeric processing
         if lnumbeg > 0 then                       'auto-number selection is ON
            if lsavbeg = 999999999& then              'use existing field value
               select case cfldtyp(1)                'select on field data type
                  case "A"                                'A' = ASCII character
                     lnumcnt = midchar(csrcfilbuf, ifldbeg)     'existing value
                  case "I"                                  'I' = Short integer
                     lnumcnt = cvi(mid$(csrcfilbuf, ifldbeg, 2))'existing value
                  case "I4"                            'I4' = Single IEEE float
                     lnumcnt = cvs(mid$(csrcfilbuf, ifldbeg, 4))'existing value
                  case "I8"                            'I8' = Double IEEE float
                     lnumcnt = cvd(mid$(csrcfilbuf, ifldbeg, 8))'existing value
                  case "L"                                   'L' = Long integer
                     lnumcnt = cvl(mid$(csrcfilbuf, ifldbeg, 4))'existing value
                  case "M4"                             'M4' = Single MBF float
                     lnumcnt = fcvs(mid$(csrcfilbuf, ifldbeg, 4))'existing value
                  case "M8"                             'M8' = Double MBF float
                     lnumcnt = dcvd(mid$(csrcfilbuf, ifldbeg, 8))'existing value
                  case else                                      'Snn' = String
                     lnumcnt = pdqvall&(mid$(csrcfilbuf, ifldbeg, ifldlen(1)))
               end select
               lnumcnt = lnumcnt + lsavcnt                  'incr.current value
            elseif lsavcnt = 999999999& then                 'use current value
               lnumcnt = lnumbeg                             'set current value
               lnumbeg = lnumbeg + 1                        'incr.current value
            else                                             'use current value
               lnumcnt = lnumbeg                             'set current value
               lnumbeg = lnumbeg + lsavcnt                  'incr.current value
            end if
            if midchar(cfldtyp(1), 1) = 83 then   'Snn' = String data fld. type
               cfldval = string$(ifldlen(1), "0")  'pre-format the field buffer
               ctmpval = ltrim$(str$(lnumcnt))    'make temp.copy of field data
               if len(ctmpval) > ifldlen(1) then  'numeric/string data overflow
                  i = ifn.msgs("Numeric data too big for string field", _
                               5, 24, 79, 1, 1) 'display error message and exit
               else                                'numeric/string length is OK
                  mid$(cfldval, ifldlen(1) - len(ctmpval) + 1) = ctmpval
               end if           'put zero-filled data into field buffer [above]
            else                                  'NOT a string data field type
               cfldval = ltrim$(str$(lnumcnt))    'make temp.copy of field data
            end if
         else                                     'auto-number selection is OFF
            cfldval = cprm(2)                     'make temp.copy of field data
         end if
   end select
   i = istr.fmti(cfldval, cfldtyp(1), ifldlen(1))'reformat to internal data type
   mid$(csrcfilbuf, ifldbeg) = cfldval     'put field data into the file buffer
   lrcdatt = lrcdatt + 1              'increment the 'nnn records read' counter
   if lrcdatt >= ldupbeg and lrcdatt >= lrcdbeg then  'count >= begin record no.
      isrcstatus = BTRV(ibtrvop, csrcposblk, csrcfilbuf, itmpbuflen, _
                        csrckeybuf, isrckeynum)  'update current Btrieve record
      if isrcstatus then                         'error updating Btrieve record
         i = BTRV(BTRV.RESET, "", "", 0, "", 0)         'close the Btrieve file
         i = ifn.msgs("Error doing " + coptmsg1 + " in " + cfil, 5, 24, 79, 1, 1)
      end if                            'display error message [above] and exit
      lrcdtot = lrcdtot + 1            'increment 'nnn records updated' counter
   end if
   if lrcdtot >= ldupcnt and lrcdtot >= lrcdcnt then 'no more records to update
      exit do                                      'update completed; exit loop
   end if
   if inxtstatus then                 'GETNEXT operation resulted in EOF status
      exit do                             'no more records available; exit loop
   end if
   lset csrcfilbuf = cnxtrcdpos         'restore 'next' Btrieve record position
   itmpbuflen = isrcbuflen            'make copy so Btrieve can't change buflen
   isrcstatus = BTRV(BTRV.GETDIRECT, csrcposblk, csrcfilbuf, itmpbuflen, _
                     csrckeybuf, isrckeynum)     'restore 'next' Btrieve record
   if isrcstatus then                              'error getting record direct
      i = BTRV(BTRV.RESET, "", "", 0, "", 0)            'close the Btrieve file
      i = ifn.msgs("Error getting record direct in " + cfil, 5, 24, 79, 1, 1)
   end if                               'display error message [above] and exit
   if ldupbeg > 0 then                    'user specified duplicates processing
      if left$(csrckeybuf, ikeypos - 1) _
      <> left$(ctmpkeybuf, ikeypos - 1) then                  'end of key-match
         exit do            'no match on next key; end of duplicates processing
      end if
   elseif lsavcnt = 999999999& then      'user specified resettable auto-number
      if left$(csrckeybuf, ikeylen) <> ctmpkeybuf then        'end of key-match
         lset ctmpkeybuf = csrckeybuf                   'reset key-match buffer
         lnumbeg = lsavbeg                    'reset auto-number begin sequence
      end if
   end if
   if io.ktst(0) = 27 then                            'user pressed the ESC key
      i = BTRV(BTRV.RESET, "", "", 0, "", 0)           'close all Btrieve files
      i = ifn.msgs("ESC selected - program aborted", 5, 24, 79, 0, 1)
   end if                               'display abort message [above] and exit
   if lrcdatt mod 100 = 0 then        '#records read counter is multiple of 100
      locate 7, 5, 0              'locate cursor for 'nnn records read' counter
      print ltrim$(str$(lrcdatt)); " records read"    'display #records message
      locate 9, 5, 0           'locate cursor for 'nnn records updated' counter
      print ltrim$(str$(lrcdtot)); " records "; coptmsg2 'rcds.-updated message
      locate 25, 80, 0                                'hide' the display cursor
   end if
loop

i = BTRV(BTRV.RESET, "", "", 0, "", 0)                  'close the Btrieve file
i = ifn.msgs("Update completed", 5, 24, 79, 0, 0)  'display 'completed' message
locate 7, 5, 1                    'locate cursor for 'nnn records read' counter
print ltrim$(str$(lrcdatt)); " "; crcdmsg2; " read"   'display #records message
locate 9, 5, 1                 'locate cursor for 'nnn records updated' counter
print ltrim$(str$(lrcdtot)); " "; crcdmsg2; " "; coptmsg2'rcds.-updated message

close                                 'close all files in case not closed above
system                                      'return control to operating system

function io.kget(inop)                       'strip key buffer and wait for key
   while inkey$ <> ""                           'begin loop to strip key buffer
   wend                                   'loop while key buffer contains a key
   do                                                               'begin loop
      ckey = inkey$                                    'get key from key buffer
   loop while ckey = ""                                'loop until a key is hit
   if asc(ckey) then                                   'key value in first byte
      io.kget = asc(ckey)                  'return key value to calling program
   else                                            'zero value ("extended" key)
      io.kget = asc(mid$(ckey, 2)) + 128       'return 2nd byte of key plus 128
   end if
end function

function io.ktst(inop)                               'return last key (no wait)
   ckey = inkey$                                       'get key from key buffer
   if ckey <> "" then                                'key buffer contains a key
      if asc(ckey) then                                'key value in first byte
         io.ktst = asc(ckey)                               'key value to return
      else                                         'zero value ("extended" key)
         io.ktst = asc(mid$(ckey, 2)) + 128    'return 2nd byte of key plus 128
      end if
   else                                      'key buffer does NOT contain a key
      io.ktst = 0                                 'set return key value to zero
   end if
end function

function iupd.pars(cstr, copt, lbeg, lcnt)        'parse begin/count specifiers
   lbeg = -1                                     'pre-set the begin value to -1
   lcnt = -1                                    'pre-set the ending value to -1
   ipos0 = istr.rsfn(len(cstr), ucase$(cstr), copt)  'user option spec position
   ipos1 = istr.lcsp(ipos0 + len(copt), cstr, " ")      'first value's position
   if ipos1 > len(cstr) then                            'first value NOT found!
      exit function                                  'return to calling routine
   end if
   if midchar(cstr, ipos1) = 126 then                  'first value is '~' char.
      ipos2 = ipos1 + 1                                 'end of the first value
   else                                                 'first value is numeric
      ipos2 = istr.lnsp(ipos1, cstr)                    'end of the first value
   end if
   ipos3 = istr.lcsp(ipos2, cstr, " ")                'comma separator position
   if ipos3 > len(cstr) then                          'separator was NOT found!
      exit function                                  'return to calling routine
   end if
   if midchar(cstr, ipos3) <> 44 then                 'separator was NOT found!
      exit function                                  'return to calling routine
   end if
   ipos4 = istr.lcsp(ipos3 + 1, cstr, " ")             'second value's position
   if ipos4 > len(cstr) then                           'second value NOT found!
      exit function                                  'return to calling routine
   end if
   if midchar(cstr, ipos4) = 126 then                 'second value is '~' char.
      ipos5 = ipos4 + 1                                'end of the second value
   else                                                'second value is numeric
      ipos5 = istr.lnsp(ipos4, cstr)                   'end of the second value
   end if
   if ipos2 = ipos1 or ipos5 = ipos4 then           '1st/second value NOT found
      exit function                                  'return to calling routine
   end if
   cbeg = mid$(cstr, ipos1, ipos2 - ipos1)             'get the begin specifier
   ccnt = mid$(cstr, ipos4, ipos5 - ipos4)             'get the count specifier
   if cbeg = "~" then                                'use existing record value
      cbeg = "999999999"                             'set to use existing value
   end if
   if ccnt = "~" then                                'use existing record value
      ccnt = "999999999"                             'set to use existing value
   end if
   if  ltrim$(str$(pdqvall&(cbeg))) = cbeg _          'begin specifier is valid
   and ltrim$(str$(pdqvall&(ccnt))) = ccnt then       'count specifier is valid
      lbeg = pdqvall&(cbeg)                          'get begin specifier value
      lcnt = pdqvall&(ccnt)                          'get count specifier value
      cstr = left$(cstr, ipos0 - 1) + mid$(cstr, ipos5)  'remove the specifiers
   end if
end function

function iupd.repl(cstr)              'replace single quotes with double quotes
   do                                   'begin loop to replace quote characters
      ipos = instr(cstr, "'")               'position of single quote character
      if ipos then                           'single quote character was found!
         mid$(cstr, ipos) = char(34)          'replace single with double quote
      else                                   'single quote character NOT found!
         exit do                               'character NOT found - exit loop
      end if
   loop
end function
