'/* CMAKS.BAS Make .CFx script file from data dictionary files */
'/*           By: Dale Thorn                                   */
'/*           Rev. 01.04.2001                                  */

'$include: 'basdef.h'
'$include: 'btrieve.h'
'$include: 'messages.h'
'$include: 'midchar.h'
'$include: 'string.h'

declare function ifn.prtfld(cfldnam, ifldtyp, ifldofs, ifldlen, ikey, ifil)

'$include: 'basdef.bas'
'$include: 'btrieve.bas'
'$include: 'messages.bas'
'$include: 'midchar.bas'
'$include: 'string.bas'

dim cfldnam(256)
dim cfldkey(256)
dim ifldtyp(256)
dim ifldofs(256)
dim ifldlen(256)

dim isegmax(9)
dim isegfld(9, 29)
dim iextlen(9, 29)
dim ckeyseg(9, 29)

ccmd = ucase$(rtrim$(command$))
if ccmd = "" then
   cls
   locate 5, 1, 1
   print "    Usage:  CMAKS  filespec"
   print
   print "    'filespec' is XBMINITEM, XBMPNTRANH, etc."
   print "    and is located in FILE/FIELD/INDEX.DDF"
   print
   print "    .DDF files must be in current directory"
   close
   system
end if

i = ifn.msgs("Please standby", 5, 24, 79, 0, 0)

csrcfilnam = "FILE.DDF"
isrcbuflen = 97
isrckeylen = 128
isrckeynum = 1
csrcfilbuf = string$(isrcbuflen, 0)
csrckeybuf = string$(isrckeylen, 0)
csrcposblk = string$(128, 0)

if BTRV(BTRV.OPEN, csrcposblk, csrcfilbuf, _
   (isrcbuflen), csrcfilnam + " ", BTRV.RO) _
then
   i = ifn.msgs("Error opening: " + csrcfilnam, 5, 24, 79, 1, 1)
end if

' Get the 'filespec' record....
crcdnam = mid$(ccmd, istr.rcfn(len(ccmd), ccmd, "\") + 1)
itmpbuflen = isrcbuflen
lset csrckeybuf = crcdnam
isrcstatus = BTRV(BTRV.GETEQ, csrcposblk, csrcfilbuf, _
                  itmpbuflen, csrckeybuf, isrckeynum)
if isrcstatus then
   i = BTRV(BTRV.RESET, "", "", 0, "", 0)
   i = ifn.msgs("Error getting record in: " + csrcfilnam, 5, 24, 79, 1, 1)
end if

' Get the file number with which to access the fields.
cfilnum = mid$(csrcfilbuf, 1, 2)

' Get the DOS filename and the output (script) filename.
cdosfil = ucase$(ltrim$(rtrim$(mid$(csrcfilbuf, 23, 40))))
ilen = len(cdosfil)
ipos = istr.rcfn(ilen, cdosfil, "\")
if ipos then
   cdosfil = mid$(cdosfil, ipos + 1)
   ilen = ilen - ipos
end if
ipos = istr.rcfn(ilen, cdosfil, ".")
if ipos = 0 then
   ipos = ilen + 1
end if
if ipos > 9 then
   ipos = 9
end if
cdstfil = left$(cdosfil, ipos - 1) + ".CF"
i = BTRV(BTRV.RESET, "", "", 0, "", 0)

csrcfilnam = "FIELD.DDF"
isrcbuflen = 32
isrckeylen = 128
isrckeynum = 4
csrcfilbuf = string$(isrcbuflen, 0)
csrckeybuf = string$(isrckeylen, 0)
csrcposblk = string$(128, 0)

if BTRV(BTRV.OPEN, csrcposblk, csrcfilbuf, _
   (isrcbuflen), csrcfilnam + " ", BTRV.RO) _
then
   i = ifn.msgs("Error opening: " + csrcfilnam, 5, 24, 79, 1, 1)
end if

itmpbuflen = isrcbuflen
lset csrckeybuf = cfilnum + string$(3, 0)
isrcstatus = BTRV(BTRV.GETGE, csrcposblk, csrcfilbuf, _
                  itmpbuflen, csrckeybuf, isrckeynum)
ifldmax = -1
while isrcstatus = 0 and mid$(csrcfilbuf, 3, 2) = cfilnum

   ' We now have a field record...
   itstlen = cvi(mid$(csrcfilbuf, 28, 2))

   if itstlen > 0 then
      ifldmax = ifldmax + 1

      cfldnam(ifldmax) = rtrim$(mid$(csrcfilbuf, 5, 20))
      cfldkey(ifldmax) = mid$(csrcfilbuf,  1, 2)
      ifldtyp(ifldmax) = asc(mid$(csrcfilbuf, 25, 1))
      ifldofs(ifldmax) = cvi(mid$(csrcfilbuf, 26, 2)) + 1
      ifldlen(ifldmax) = itstlen

      if ifldmax > 0 then
         if ifldofs(ifldmax) <> ifldofs(ifldmax - 1) + ifldlen(ifldmax - 1) then
            i = ifn.msgs("Field offset error in: " + csrcfilnam, 5, 24, 79, 1, 0)
         end if
      end if
   end if

   itmpbuflen = isrcbuflen
   isrcstatus = BTRV(BTRV.GETNEXT, csrcposblk, csrcfilbuf, _
                     itmpbuflen, csrckeybuf, isrckeynum)
wend
i = BTRV(BTRV.RESET, "", "", 0, "", 0)

csrcfilnam = "INDEX.DDF"
isrcbuflen = 10
isrckeylen = 128
isrckeynum = 2
csrcfilbuf = string$(isrcbuflen, 0)
csrckeybuf = string$(isrckeylen, 0)
csrcposblk = string$(128, 0)

if BTRV(BTRV.OPEN, csrcposblk, csrcfilbuf, _
   (isrcbuflen), csrcfilnam + " ", BTRV.RO) _
then
   i = ifn.msgs("Error opening: " + csrcfilnam, 5, 24, 79, 1, 1)
end if

itmpbuflen = isrcbuflen
lset csrckeybuf = cfilnum + string$(4, 0)
isrcstatus = BTRV(BTRV.GETGE, csrcposblk, csrcfilbuf, _
                  itmpbuflen, csrckeybuf, isrckeynum)
ikeymax = -1
while isrcstatus = 0 _
and mid$(csrcfilbuf, 1, 2) = cfilnum _
and cvi(mid$(csrcfilbuf, 5, 2)) <= 9

   ' We now have an index segment record...
   for ifldnum = 0 to ifldmax
      if cfldkey(ifldnum) = mid$(csrcfilbuf, 3, 2) then
         exit for
      end if
   next
   ikeynum = cvi(mid$(csrcfilbuf, 5, 2))
   if ikeymax < ikeynum then
      ikeymax = ikeynum
      isegmax(ikeynum) = 0
   else
      isegmax(ikeynum) = isegmax(ikeynum) + 1
   end if
   isegfld(ikeynum, isegmax(ikeynum)) = ifldnum

   select case ifldtyp(ifldnum)
      case DTYP.AUTOINC, _
           DTYP.BOOLEAN, _
           DTYP.BTRVDATE, _
           DTYP.BTRVTIME, _
           DTYP.INTEGER
         if ifldlen(ifldnum) = 2 then
            ckeyseg(ikeynum, isegmax(ikeynum)) = "II"
            iextlen(ikeynum, isegmax(ikeynum)) = 5
         elseif ifldlen(ifldnum) = 4 then
            ckeyseg(ikeynum, isegmax(ikeynum)) = "LLLL"
            iextlen(ikeynum, isegmax(ikeynum)) = 10
         else
            ckeyseg(ikeynum, isegmax(ikeynum)) = string$(ifldlen(ifldnum), "X")
            iextlen(ikeynum, isegmax(ikeynum)) = ifldlen(ifldnum)
         end if
      case DTYP.STRING
         ckeyseg(ikeynum, isegmax(ikeynum)) = string$(ifldlen(ifldnum), "C")
         iextlen(ikeynum, isegmax(ikeynum)) = ifldlen(ifldnum)
      case else
         ckeyseg(ikeynum, isegmax(ikeynum)) = string$(ifldlen(ifldnum), "X")
         iextlen(ikeynum, isegmax(ikeynum)) = ifldlen(ifldnum)
   end select

   itmpbuflen = isrcbuflen
   isrcstatus = BTRV(BTRV.GETNEXT, csrcposblk, csrcfilbuf, _
                     itmpbuflen, csrckeybuf, isrckeynum)
wend
i = BTRV(BTRV.RESET, "", "", 0, "", 0)

if ifldmax <= 22 then
   idspmax = ifldmax
else
   idspmax = 22
end if

' Create script files for each Btrieve key number.
for ikeynum = 0 to ikeymax
   ckeymsk = ckeyseg(ikeynum, 0)
   ckeynam = cfldnam(isegfld(ikeynum, 0))
   for isegnum = 1 to isegmax(ikeynum)
      ckeymsk = ckeymsk + ckeyseg(ikeynum, isegnum)
      ckeynam = ckeynam + "/" + cfldnam(isegfld(ikeynum, isegnum))
   next
   ckeylen = ltrim$(str$(len(ckeymsk)))
   ckeynum = ltrim$(str$(ikeynum))

   ' Now that we're ready to process fields, open the output (script) file.
   open cdstfil + ckeynum for output as 1
   print #1, "No. of Btrieve files-----------------------------------------------------------"
   print #1, "1"
   print #1, "Filename, record length, key#, key length, padding, mask-----------------------"
   print #1, cdosfil; ", 4096, "; ckeynum; ", "; ckeylen; ", , "; ckeymsk
   print #1, "*** Note: key segments for file #1 apply to search fields only"
   print #1, "*** and are loaded from key #1; segments for file 2 and up are"
   print #1, "*** loaded from the file #1 data record----------------------------------------"
   print #1, "No. key segments, begin and length for each segment----------------------------"
   print #1, ltrim$(str$(isegmax(ikeynum) + 1));
   isegpos = 1
   for isegnum = 0 to isegmax(ikeynum)
      iseglen = ifldlen(isegfld(ikeynum, isegnum))
      print #1, ", "; ltrim$(str$(isegpos)); ", "; ltrim$(str$(iseglen));
      isegpos = isegpos + iseglen
   next
   print #1, ""
   print #1, "Browse field display padding (0 = no, -1 = yes)--------------------------------"
   print #1, "-1"
   print #1, "Hold one line at top/bottom when paging (0=no, -1=yes)-------------------------"
   print #1, "-1"
   print #1, "No. of search fields-----------------------------------------------------------"
   print #1, "1"
   print #1, "Search field QS field no., start column, width---------------------------------"
   print #1, "1, 3, "; ltrim$(str$(iextlen(ikeynum, 0)))
   print #1, "Minimum key value possible this file; one character only (use ASCII table no.)"
   print #1, "0"
   print #1, "Maximum key value possible this file; one character only (use ASCII table no.)"
   print #1, "255"
   print #1, "Browse main header title-------------------------------------------------------"
   print #1, crcdnam; " by "; ckeynam
   print #1, "Message: ..........not found  [optional] --------------------------------------"
   print #1, "Records"
   print #1, "No. of Browse data fields------------------------------------------------------"
   print #1, ltrim$(str$(idspmax + 1))
   for isegnum = 0 to isegmax(ikeynum)
      ifldnum = isegfld(ikeynum, isegnum)
      i = ifn.prtfld(cfldnam(ifldnum), ifldtyp(ifldnum), _
                     ifldofs(ifldnum), ifldlen(ifldnum), 1, 1)
   next
   for ifldnum = 0 to ifldmax
      for isegnum = 0 to isegmax(ikeynum)
         if isegfld(ikeynum, isegnum) = ifldnum then
            exit for
         end if
      next
      if isegnum > isegmax(ikeynum) then
         i = ifn.prtfld(cfldnam(ifldnum), ifldtyp(ifldnum), _
                        ifldofs(ifldnum), ifldlen(ifldnum), 0, 1)
      end if
   next
   close 1
next

i = ifn.msgs("Process completed for " + crcdnam, 5, 24, 79, 0, 1)
close
system

function ifn.prtfld(cfldnam, ifldtyp, ifldofs, ifldlen, ikey, ifil)
   cfldbeg = ltrim$(str$(ifldofs))
   cfldlen = ltrim$(str$(ifldlen))
   select case ifldtyp
      case DTYP.AUTOINC, _
           DTYP.BOOLEAN, _
           DTYP.INTEGER
         if ifldlen = 1 then
            cfldtyp = "A1"
            idsplen = 3
         elseif ifldlen = 2 then
            if ikey then
               cfldtyp = "N2"
            else
               cfldtyp = "N1"
            end if
            idsplen = 5
         else
            if ikey then
               cfldtyp = "N4"
            else
               cfldtyp = "N3"
            end if
            idsplen = 10
         end if
      case DTYP.BFLOAT
         if ifldlen = 4 then
            cfldtyp = "N5"
            idsplen = 11
         else
            cfldtyp = "N7"
            idsplen = 17
         end if
      case DTYP.BTRVDATE
         cfldtyp = "D5"
         idsplen = 10
      case DTYP.BTRVTIME
         cfldtyp = "T5"
         idsplen = 8
      case DTYP.FLOAT
         if ifldlen = 4 then
            cfldtyp = "I5"
            idsplen = 11
         else
            cfldtyp = "I7"
            idsplen = 17
         end if
      case DTYP.NOTE1, _
           DTYP.NOTE2, _
           DTYP.STRING
         cfldtyp = "C1"
         idsplen = ifldlen
      case else
         i = ifn.msgs("Unspecified fieldtype: " + ltrim$(str$(ifldtyp)), _
                      5, 24, 79, 1, 1)
   end select
   inamlen = len(cfldnam) \ 2 + len(cfldnam) mod 2
   if idsplen < inamlen then
      idsplen = inamlen
   end if
   if idsplen < 2 then
      idsplen = 2
   elseif idsplen > 76 then
      idsplen = 76
   end if
   cdsplen = ltrim$(str$(idsplen))
   print #ifil, "Title, Type, Width (0=autoconfig), Btrv start, Btrv length, source file"
   print #ifil, ",";  cfldnam; ", "; cfldtyp; ", "; cdsplen; _
                ", "; cfldbeg; ", "; cfldlen; ", 1"
end function
