'/* FILESTRB.BAS Make file structure from data dictionary files */
'/*              By: Dale Thorn                                 */
'/*              Rev. 02.08.2002                                */

'$include: 'basdef.h'
'$include: 'btrieve.h'
'$include: 'messages.h'
'$include: 'midchar.h'
'$include: 'string.h'

declare function cfn.pgsz(ircdsiz)

'$include: 'basdef.bas'
'$include: 'btrieve.bas'
'$include: 'messages.bas'
'$include: 'midchar.bas'
'$include: 'string.bas'

dim cfldnam(256)
dim cfldkey(256)
dim ifldtyp(256)
dim ifldofs(256)
dim ifldlen(256)
dim ikeyatt(256)

ccmd = ucase$(rtrim$(command$))
if ccmd = "" then
   cls
   locate 5, 1, 1
   print "    Usage:  FILESTRB  filespec  [/B#]  [/T]"
   print
   print "    'filespec' is APSERIAL, SCONEONEREC, etc., and"
   print "    is located in FILE/FIELD/INDEX.DDF data dictionary"
   print
   print "    Data dictionary files must be in current directory"
   print
   print "    If /B# specified, base file offsets from # (0 or 1)"
   print "    If /T specified, output text with Laser print codes"
   close
   system
end if

ioffset = 1
itxonly = not 0
imsgdisp = not 0
do
   if right$(ccmd, 2) = "/T" then
      itxonly = 0
      ccmd = rtrim$(left$(ccmd, len(ccmd) - 2))
   elseif right$(ccmd, 2) = "/N" then
      imsgdisp = 0
      ccmd = rtrim$(left$(ccmd, len(ccmd) - 2))
   elseif left$(right$(ccmd, 3), 2) = "/B" then
      ioffset = pdqvali(right$(ccmd, 1))
      if ioffset < 0 or ioffset > 1 then
         i = ifn.msgs("Invalid offset spec", 5, 24, 79, 1, 1)
      end if
      ccmd = rtrim$(left$(ccmd, len(ccmd) - 3))
   else
      exit do
   end if
loop

' Define print-control variables.
if itxonly then
   cbldclr = ""
   cbldset = ""
   cprtclr = ""
else
   cbldclr = "(s0B"
   cbldset = "(s3B"
   cprtclr = "E"
end if

if imsgdisp then
   i = ifn.msgs("Please standby", 5, 24, 79, 0, 0)
end if

csrcfilnam = "FILE.DDF"
isrcbuflen = 97
isrckeylen = 128
isrckeynum = 1
csrcfilbuf = string$(isrcbuflen, 0)
csrckeybuf = string$(isrckeylen, 0)
csrcposblk = string$(128, 0)

if BTRV(BTRV.OPEN, csrcposblk, csrcfilbuf, _
   (isrcbuflen), csrcfilnam + " ", BTRV.RO) _
then
   i = ifn.msgs("Error opening: " + csrcfilnam, 5, 24, 79, 1, 1)
end if

' Get the 'filespec' record....
crcdnam = mid$(ccmd, istr.rcfn(len(ccmd), ccmd, "\") + 1)
itmpbuflen = isrcbuflen
lset csrckeybuf = crcdnam
isrcstatus = BTRV(BTRV.GETEQ, csrcposblk, csrcfilbuf, _
                  itmpbuflen, csrckeybuf, isrckeynum)
if isrcstatus then
   i = BTRV(BTRV.RESET, "", "", 0, "", 0)
   i = ifn.msgs("Error getting record in: " + csrcfilnam, 5, 24, 79, 1, 1)
end if

' Get the file number with which to access the fields.
cfilnum = mid$(csrcfilbuf, 1, 2)

' Get the DOS filename and the output (script) filename.
cdosfil = ucase$(cstr.trim(mid$(csrcfilbuf, 23, 40)))
ilen = len(cdosfil)
ipos = istr.rcfn(ilen, cdosfil, "\")
if ipos then
   cdosfil = mid$(cdosfil, ipos + 1)
   ilen = ilen - ipos
end if
ipos = istr.rcfn(ilen, cdosfil, ".")
if ipos = 0 then
   ipos = ilen + 1
end if
if ipos > 9 then
   ipos = 9
end if
select case cdosfil
   case "APONE", _
        "ARONE", _
        "BBONE", _
        "BCONE", _
        "CSONE", _
        "FEONE", _
        "FMONE", _
        "GLONE", _
        "IMONE", _
        "INONE", _
        "JCONE", _
        "LAONE", _
        "LOONE", _
        "NLONE", _
        "OEONE", _
        "ORONE", _
        "PHONE", _
        "PLONE", _
        "PNONE", _
        "PUONE"
      ctmp1 = left$(crcdnam, len(crcdnam) - 2)
      ctmp2 = right$(crcdnam, 2)
      ctmp3 = ltrim$(str$(midchar(ctmp2, 1)))
      ctmp4 = ltrim$(str$(midchar(ctmp2, 2)))
      cdstfil = left$(ctmp1, 6) + ctmp2 + ".STR"
   case "ARDEFLTS", _
        "INMSPECD", _
        "ORBOLST", _
        "ORCNTRCT", _
        "PUCNTRCT", _
        "RPTREC.TMP"
      ctmp1 = left$(crcdnam, len(crcdnam) - 2)
      cdstfil = left$(ctmp1, 6) + right$(crcdnam, 2) + ".STR"
   case else
      select case crcdnam
         case "SCCONFIGONEREC"
            cdstfil = "SCCONFR1.STR"
         case "SCCONFIGTWOREC"
            cdstfil = "SCCONFR2.STR"
         case "SCONEONEREC"
            cdstfil = "SCONER1.STR"
         case "SCONETWOREC"
            cdstfil = "SCONER2.STR"
         case "SCONETHRREC"
            cdstfil = "SCONER3.STR"
         case "SCONEFOUREC"
            cdstfil = "SCONER4.STR"
         case else
            cdstfil = left$(cdosfil, ipos - 1) + ".STR"
      end select
end select
clogfil = left$(cdstfil, len(cdstfil) - 4) + ".LOG"
i = BTRV(BTRV.RESET, "", "", 0, "", 0)

'Open the destination text file and log/error file.
open cdstfil for output as 1
open clogfil for output as 2

csrcfilnam = "INDEX.DDF"
isrcbuflen = 10
isrckeylen = 128
isrckeynum = 2
csrcfilbuf = string$(isrcbuflen, 0)
csrckeybuf = string$(isrckeylen, 0)
csrcposblk = string$(128, 0)

if BTRV(BTRV.OPEN, csrcposblk, csrcfilbuf, _
   (isrcbuflen), csrcfilnam + " ", BTRV.RO) _
then
   i = ifn.msgs("Error opening: " + csrcfilnam, 5, 24, 79, 1, 1)
end if

itmpbuflen = isrcbuflen
lset csrckeybuf = cfilnum + string$(4, 0)
isrcstatus = BTRV(BTRV.GETGE, csrcposblk, csrcfilbuf, _
                  itmpbuflen, csrckeybuf, isrckeynum)
iduplen = 0
isavkey = -1
while isrcstatus = 0 and mid$(csrcfilbuf, 1, 2) = cfilnum
   ' We now have an index record...
   ikeynum = cvi(mid$(csrcfilbuf, 5, 2))
   ikeyatt(ikeynum) = asc(mid$(csrcfilbuf, 9, 1))
   if isavkey <> ikeynum then
      isavkey = ikeynum
      if ikeyatt(ikeynum) and 1 then
         iduplen = iduplen + 8
      end if
   end if
   itmpbuflen = isrcbuflen
   isrcstatus = BTRV(BTRV.GETNEXT, csrcposblk, csrcfilbuf, _
                     itmpbuflen, csrckeybuf, isrckeynum)
wend
i = BTRV(BTRV.RESET, "", "", 0, "", 0)

csrcfilnam = "FIELD.DDF"
isrcbuflen = 32
isrckeylen = 128
isrckeynum = 4
csrcfilbuf = string$(isrcbuflen, 0)
csrckeybuf = string$(isrckeylen, 0)
csrcposblk = string$(128, 0)

if BTRV(BTRV.OPEN, csrcposblk, csrcfilbuf, _
   (isrcbuflen), csrcfilnam + " ", BTRV.RO) _
then
   i = ifn.msgs("Error opening: " + csrcfilnam, 5, 24, 79, 1, 1)
end if

itmpbuflen = isrcbuflen
lset csrckeybuf = cfilnum + string$(3, 0)
isrcstatus = BTRV(BTRV.GETGE, csrcposblk, csrcfilbuf, _
                  itmpbuflen, csrckeybuf, isrckeynum)
ifldmax = -1
while isrcstatus = 0 and mid$(csrcfilbuf, 3, 2) = cfilnum

   ' We now have a field record...
   itstlen = cvi(mid$(csrcfilbuf, 28, 2))

   if itstlen > 0 then
      ifldmax = ifldmax + 1

      cfldnam(ifldmax) = space$(30)
      lset cfldnam(ifldmax) = cstr.trim(mid$(csrcfilbuf, 5, 20))
      cfldkey(ifldmax) = mid$(csrcfilbuf, 1, 2)
      ifldtyp(ifldmax) = asc(mid$(csrcfilbuf, 25, 1))
      ifldofs(ifldmax) = cvi(mid$(csrcfilbuf, 26, 2))
      ifldlen(ifldmax) = itstlen

      if ifldmax > 0 then
         if ifldofs(ifldmax) <> ifldofs(ifldmax - 1) + ifldlen(ifldmax - 1) then
            print #2, "Field offset error in "; crcdnam; " at position "; _
                      ltrim$(str$(ifldofs(ifldmax)))
         end if
      end if
   end if

   itmpbuflen = isrcbuflen
   isrcstatus = BTRV(BTRV.GETNEXT, csrcposblk, csrcfilbuf, _
                     itmpbuflen, csrckeybuf, isrckeynum)
wend
i = BTRV(BTRV.RESET, "", "", 0, "", 0)

' Record length is last field offset (base 0) plus last field length.
ircdlen = ifldofs(ifldmax) + ifldlen(ifldmax)
crcdlen = ltrim$(str$(ircdlen))
cpagesz = cfn.pgsz(ircdlen + iduplen)

print #1, cprtclr; space$(30); cbldset; "Btrieve File Layout"; cbldclr
print #1, ""
print #1, cbldset; "Record Length: "; cbldclr; crcdlen; _
          space$(40 - len(crcdlen)); _
          cbldset; "Table Name: "; cbldclr; crcdnam
print #1, cbldset; "Page Size    : "; cbldclr; cpagesz; _
          space$(40 - len(cpagesz)); _
          cbldset; "File Name : "; cbldclr; cdosfil
print #1, ""
print #1, space$(31); _
          cbldset; "DATA FLD FLD"; cbldclr
print #1, cbldset; "FIELD DESCRIPTION"; _
          space$(14); _
          "TYPE BEG LEN RANGE/NOTES"; cbldclr
print #1, cbldset; string$(79, "="); cbldclr

for ifldnum = 0 to ifldmax

   ' We now have a field record...
   cfldofs = right$("   " + str$(ifldofs(ifldnum) + ioffset), 4)
   cfldlen = right$("   " + str$(ifldlen(ifldnum)), 4)

   select case ifldtyp(ifldnum)
      case DTYP.AUTOINC, _
           DTYP.BOOLEAN, _
           DTYP.INTEGER
         if ifldlen(ifldnum) = 1 then
            cfldtyp = "Byt"
         else
            cfldtyp = "Int"
         end if
      case DTYP.BFLOAT
         cfldtyp = "Bfl"
      case DTYP.BTRVDATE
         cfldtyp = "Dat"
      case DTYP.BTRVTIME
         cfldtyp = "Tim"
      case DTYP.FLOAT
         cfldtyp = "Flt"
      case DTYP.NOTE1, _
           DTYP.NOTE2
         cfldtyp = "Not"
      case DTYP.STRING
         cfldtyp = "Str"
      case else
         i = ifn.msgs("Unspecified fieldtype: " + _
                      ltrim$(str$(ifldtyp(ifldnum))), 5, 24, 79, 1, 1)
   end select

   print #1, cfldnam(ifldnum); "|"; cfldtyp; "|"; cfldofs; "|"; cfldlen "|"
next

print #1, ""
print #1, space$(32); _
          cbldset; "FLD FLD KEY SEG"; cbldclr
print #1, cbldset; "INDEX DESCRIPTION"; _
          space$(15); _
          "BEG LEN NUM NUM DUP MOD NOTES"; cbldclr
print #1, cbldset; string$(79, "="); cbldclr

csrcfilnam = "INDEX.DDF"
isrcbuflen = 10
isrckeylen = 128
isrckeynum = 2
csrcfilbuf = string$(isrcbuflen, 0)
csrckeybuf = string$(isrckeylen, 0)
csrcposblk = string$(128, 0)

if BTRV(BTRV.OPEN, csrcposblk, csrcfilbuf, _
   (isrcbuflen), csrcfilnam + " ", BTRV.RO) _
then
   i = ifn.msgs("Error opening: " + csrcfilnam, 5, 24, 79, 1, 1)
end if

itmpbuflen = isrcbuflen
lset csrckeybuf = cfilnum + string$(4, 0)
isrcstatus = BTRV(BTRV.GETGE, csrcposblk, csrcfilbuf, _
                  itmpbuflen, csrckeybuf, isrckeynum)
isavkey = 0
while isrcstatus = 0 and mid$(csrcfilbuf, 1, 2) = cfilnum

   ' We now have an index record...
   ikeynum = cvi(mid$(csrcfilbuf, 5, 2))
   ikeyseg = cvi(mid$(csrcfilbuf, 7, 2))

   ckeynum = right$("  " + str$(ikeynum), 3)
   ckeyseg = right$("  " + str$(ikeyseg), 3)

   for ifldnum = 0 to ifldmax
      if cfldkey(ifldnum) = mid$(csrcfilbuf, 3, 2) then
         exit for
      end if
   next

   cfldofs = right$("   " + str$(ifldofs(ifldnum) + ioffset), 4)
   cfldlen = right$("   " + str$(ifldlen(ifldnum)), 3)

   if ikeyatt(ikeynum) and 1 then
      cdup = "Y"
   else
      cdup = "N"
   end if
   if ikeyatt(ikeynum) and 2 then
      cmod = "Y"
   else
      cmod = "N"
   end if

   if isavkey < ikeynum then
      isavkey = ikeynum
      print #1, space$(30); "|    |   |   |   |   |   |"
   end if

   print #1, cfldnam(ifldnum); "|"; cfldofs; "|"; cfldlen; "|"; _
             ckeynum; "|"; ckeyseg; "| "; cdup; " | "; cmod; " |"

   itmpbuflen = isrcbuflen
   isrcstatus = BTRV(BTRV.GETNEXT, csrcposblk, csrcfilbuf, _
                     itmpbuflen, csrckeybuf, isrckeynum)
wend
i = BTRV(BTRV.RESET, "", "", 0, "", 0)

if not itxonly then
   ' Now that we're done, reopen the destination text file
   ' to replace the c/r-l/f with a Laser printer reset code.
   close
   open cdstfil for binary as 1
   llof = lof(1)

   cbuf = char(32)
   get 1, llof, cbuf
   if cbuf = char(26) then
      cbuf = char(32)
      put 1, llof - 2, cbuf
   end if
   cbuf = cprtclr
   put 1, llof - 1, cbuf
end if

close
if imsgdisp then
   shell "brow " + cdstfil
end if
system

function cfn.pgsz(ircdsiz) static
   ipagesz = 4096
   dsaveloss = 1
   for itstsiz = 506 to 2042 step 512
      if ircdsiz <= itstsiz then
         imodsiz = itstsiz mod ircdsiz
         dtestloss = cdbl(imodsiz) / cdbl(itstsiz - imodsiz)
         if dsaveloss > dtestloss then
            dsaveloss = dtestloss
            ipagesz = itstsiz + 6
         end if
      end if
   next
   cfn.pgsz = ltrim$(str$(ipagesz))
end function
