'/* RTAB.BAS Remove "hard" tab characters from a text file */
'/*          By: Dale Thorn                                */
'/*          Rev. 27.01.2000                               */

'$include: 'basdef.h'
'$include: 'filekill.h'
'$include: 'fileopen.h'
'$include: 'longname.h'
'$include: 'messages.h'
'$include: 'midchar.h'
'$include: 'parmstr1.h'
'$include: 'string.h'
'$include: 'basdef.bas'
'$include: 'filekill.bas'
'$include: 'fileopen.bas'
'$include: 'longname.bas'
'$include: 'messages.bas'
'$include: 'midchar.bas'
'$include: 'parmstr1.bas'
'$include: 'string.bas'
'$include: 'scrnparm.bas'

ccmd = ucase$(rtrim$(command$))            'get the DOS command-line parameters
if ccmd = "" then                              'a command line was NOT supplied
   i = ifn.msgs("Usage:  RTAB  filename  [/tabsize]", iofs, irow, icol, 0, 1)
end if                              'display the usage message [above] and exit

iprm = parmstr1(ccmd, cfil, cnam, cext, cprm())  'parse command-line parameters
if iprm > 0 then                          'no. of parameters was > 1 (too many)
   i = ifn.msgs("Invalid number of parameters", iofs, irow, icol, 1, 1)
end if                      'display no.-of-parameters message [above] and exit

if cnam = "" or len(cnam) > 8 or len(cext) > 3 or instr(cext, ".") then
   i = ifn.msgs("Invalid filename", iofs, irow, icol, 1, 1)   'invalid filename
end if                       'display invalid-filename message [above] and exit

if iprm = 0 then                             'a tab-size parameter was supplied
   itab = pdqvali(cprm(0))                 'numeric value of tab-size parameter
   if itab > 99 or ltrim$(str$(itab)) <> cprm(0) then'invalid tab specification
      i = ifn.msgs("Invalid tabsize parameter", iofs, irow, icol, 1, 1)
   end if                   'display invalid-parameter message [above] and exit
else                                     'a tab-size parameter was NOT supplied
   itab = 8                                      'set the default tab size to 8
end if

i = ifn.open(1, cfil, "B", llof)           'open the source file in binary mode
if llof < 0 then                                'user input a wildcard filespec
   i = ifn.msgs("Invalid filename", iofs, irow, icol, 1, 1)      'beep and exit
elseif llof = 0 then                          'source file nonexistent or empty
   i = ifn.kill(1, cfil)                             'kill the zero-length file
   i = ifn.msgs(cfil + " not found", iofs, irow, icol, 1, 1)     'beep and exit
end if

i = ifn.msgs("Please standby", iofs, irow, icol, 0, 0) 'hide cursor and proceed

ctab = char(9)                                         'tab character (ASCII 9)
i = ifn.kill(1, "rtab.tmp")                            'kill the temporary file
name cfil as "rtab.tmp"             'rename the source file to a temporary name
shell "copy rtab.tmp " + cfil + " > nul"        'make a copy of the source file
open cfil for input as 1                                  'open the source file
open "rtab.tmp" for output as 2                      'open the destination file
do while not eof(1)                            'loop thru the source-file lines
   line input #1, clin                        'read a line from the source file
   i = ifn.rtab(clin, itab)                'replace tab characters in text line
   print #2, rtrim$(clin)           'write the processed line to the dest. file
loop
close                                          'close the source and temp files
i = ifn.kill(1, cfil)                          'kill the original (source) file
name "rtab.tmp" as cfil               'change temp filename to source-file name

i = ifn.msgs("Hard tabs removed for: " + cfil, iofs, irow, icol, 0, 1)
close                                 'close all files in case not closed above
system                                              'return to operating system
